﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;
using OuDot.Properties;
using OuDot.ServicesOudot;

namespace OuDot
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        private void Application_Startup(object sender, StartupEventArgs e)
        {
            AppDomain.CurrentDomain.FirstChanceException += CurrentDomain_FirstChanceException;


            //Občas docházelo k poškození konfiguračního souboru
            //Program poté nanaběhl a konfigurační soubor se musel smazat ručně
            //Následují kód testuje zda lze číst z konfiguračního souboru; pokud nelze je konfigurační soubor smazán
            try
            {
                System.Configuration.Configuration config = System.Configuration.ConfigurationManager.OpenExeConfiguration(System.Configuration.ConfigurationUserLevel.PerUserRoamingAndLocal);
            }
            catch (System.Configuration.ConfigurationException ex)
            {
                if (System.IO.File.Exists(ex.Filename))
                {
                    try
                    {
                        MessageBox.Show("Konfigurační soubor byl poškozen. Nastavení bude načteno z předchozí verze.", "BDBConverter", MessageBoxButton.OK, MessageBoxImage.Warning);
                        System.IO.File.Delete(ex.Filename);
                    }
                    catch (Exception) { }
                }
            }
            catch (Exception) { }

            //Při změně verze se musí načíst nastavení z minulé verze
            //Nastavení se změní i když není setting soubor k dispozici (je smazán)
            if (Settings.Default.SettingsMustUpgrade)
            {
                try
                {
                    //Může nastat chyba, pokud je poškozena verze předchozího konfiguračního souboru
                    Settings.Default.Upgrade();
                }
                catch (Exception ex)
                {
                    Log.LogException(ex, "Settings upgrade");
                }
                Settings.Default.SettingsMustUpgrade = false;
                Settings.Default.Save();
            }
        }

        void CurrentDomain_FirstChanceException(object sender, System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs e)
        {
            Exception ex = e.Exception;
            Log.LogException(ex,"Ošetřená vyjímka.");
        }
    }
}
