﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using OuDot.ServicesOudot;


namespace OuDot.Model
{
    public partial class OU_ODVOZ_UKAZ
    {

        public int SoucetVsechZdroju
        {
            get
            {
                int soucet = this.BDBC_PRIMARNI_KLICE.Count + this.BDBC_SLOUPCE.Count + this.CISEL_SEZNAM.Count + this.OU_ODVOZ_UKAZ1.Count + this.EXT_SLOUPCE.Count;
                return soucet;
            }
        }

        /// <summary>
        /// Neukládá se do DB, slouží pouze k výběru např.: datagridu
        /// </summary>
        public bool Vyber { get; set; }

        #region Bubble properties

        //public OU_FUNKCE BubbleOU_FUNKCE 
        //{
        //    get 
        //    { 
        //        return this.OU_FUNKCE; 
        //    }
        //    set
        //    {
        //        if (this.OU_FUNKCE != value) //dependency property?
        //        {
        //            if (value.ID != 1)//Pokud měním na Vlastní (ID 1) neměním sql kód
        //            {
        //                string generovaneSQL = ZmenaFunkce(value);
        //                if (generovaneSQL != null)
        //                {
        //                    this.OU_FUNKCE = value;
        //                    this.SQL_DOTAZ = generovaneSQL;
        //                }
        //                else
        //                {
        //                    Application.Current.Dispatcher.BeginInvoke(
        //                    new Action(() =>
        //                    {

        //                        BubbleOU_FUNKCE = OU_FUNKCE;
        //                        //OnPropertyChanged("BubbleOU_FUNKCE");
        //                    }), System.Windows.Threading.DispatcherPriority.ContextIdle, null);
        //                    return;
        //                }
        //            }
        //            else
        //            {
        //                this.OU_FUNKCE = value;
        //            }

        //        }


        //    }
        //}



        #endregion Bubble properties


        public void Pridej(OU_TAB Tabulka)
        {
            if (Tabulka.OU_PRIMARNI_KLICE.Count == 0)
            {
                throw new Exception("Chybí primární klíč tabulky.");
            }
            this.NAZEV = "Nový";
            this.ID_FUNKCE = 1;//u nového OU nastavím počáteční funkci na Vlastní
            this.STAV = false;//stav nového OU nastavím flase
            this.DATA_TYP = 0;// nulový datový typ
            this.OU_TAB = Tabulka;
            DBContext.Instance.Entity.OU_ODVOZ_UKAZ.Add(this);


        }


        internal string ZmenaFunkce(OU_FUNKCE FunkceVyb)
        {
            //PARAMETRY SE MUSÍ ZADAT PŘEDEM, PROTOŽE PŘI KLONOVÁNÍ DO NOVÉHO OBDOBÍ POUŽIJI FUNKCI GENEROVAT A TA SI JIŽ HODNOTY PARAMETRŮ VEME Z DATBÁZE A ZNOVU SE NEZADÁVAJÍ
            OuDot.ViewModel.PomocnaOkna.NastavHodnotuWindow nhw = new ViewModel.PomocnaOkna.NastavHodnotuWindow();
            bool? NastavHodnotuWindowResult = true;
            switch (FunkceVyb.NAZEV)
            {
                case "Konstanta":
                    //Zobrazím uživateli okno pro zadání konstanty
                    nhw.Title = this.NAZEV;
                    nhw.tblHodnotaLabel.Text = "Konstanta: ";
                    NastavHodnotuWindowResult = nhw.ShowDialog();
                    OU_PARAM_FCE newFceParam = new OU_PARAM_FCE { OU_ODVOZ_UKAZ = this, TYP_PARAM = ServicesOudot.ParamFceEnum.konstanta.ToString(), HODNOTA = nhw.tbKonstanta.Text };
                    DBContext.Instance.Entity.OU_PARAM_FCE.Add(newFceParam);
                    break;
                case "Podřízené převzetí":
                    //Zobrazím uživateli okno pro zadání konstanty
                    TypZdroj typZdroje = GenerovaniSQL.ZjistiTypZdroje(this, 1);
                    nhw.Title = this.NAZEV;
                    string neshodnyPKSloupec = GenerovaniSQL.NeshodnySloupecPK(this.OU_TAB.OU_PRIMARNI_KLICE.Select(p => p.JMENO).ToList(), GenerovaniSQL.ZjistiJmenaPKZdroje(this, typZdroje));
                    nhw.tblHodnotaLabel.Text = $"Konstanta pro sloupec {neshodnyPKSloupec}: ";
                    NastavHodnotuWindowResult = nhw.ShowDialog();
                    OU_PARAM_FCE newFceParamPodrPr = null;
                    if (nhw.cbIgnorovatSloupec.IsChecked == true)//Pokud uživatel zaškrtl ignorovat sloupec
                    {
                        newFceParamPodrPr = new OU_PARAM_FCE { OU_ODVOZ_UKAZ = this, TYP_PARAM = ServicesOudot.ParamFceEnum.ignorovatSloupec.ToString()};
                    }
                    else//Pokud vyplnil konstantu pro sloupec
                    {
                        newFceParamPodrPr = new OU_PARAM_FCE { OU_ODVOZ_UKAZ = this, TYP_PARAM = ServicesOudot.ParamFceEnum.konstanta.ToString(), HODNOTA = nhw.tbKonstanta.Text };
                    }
                    
                    DBContext.Instance.Entity.OU_PARAM_FCE.Add(newFceParamPodrPr);

                    break;
                default:
                    break;
            }
            //Pokud byl chybný výsledek uzavření nastavovacího okna vyhodím chybu
            if (NastavHodnotuWindowResult != true)
            {
                throw new OperationCanceledException("Operace byla ukončena.");
            }

            return GenerovaniSQL.GenerujSQL(this, FunkceVyb);
        }


        #region Zdroje

        public void OdeberBdbcZdroj(BDBC_SLOUPCE Sloupec)
        {
            this.BDBC_SLOUPCE.Remove(Sloupec);
        }

        public void OdeberZdrojovyOdvozUkaz(OU_ODVOZ_UKAZ ZdrojovyOU)
        {
            this.OU_ODVOZ_UKAZ1.Remove(ZdrojovyOU);
        }

        public void OdeberBdbcPK(BDBC_PRIMARNI_KLICE BdbcPK)
        {
            this.BDBC_PRIMARNI_KLICE.Remove(BdbcPK);
        }

        public void OdeberCisel()
        {
            throw new NotImplementedException("Není hotové.");
        }

        /// <summary>
        /// Přidává zdrojové definované sloupce k odvozenému ukazateli z BDBConverteru
        /// </summary>
        /// <param name="Zdroje"></param>
        public void PridejBdbcZdroj(BDBC_SLOUPCE Sloupec)
        {

            //if (this.OU_TAB != null)
            //{
            //    //Musim zkontrolovat vechny nadrazene ou s jejich tabulkama
            //    //Spustím kontrolu zdroje
            //    KontrolaBDBCZdroje(Sloupec,this.OU_TAB);
            //    RekurzivniKontrolaNadrazenychZdrojuOU(this, Sloupec);
            //}

            if (this.BDBC_SLOUPCE.Contains(Sloupec))
            {
                throw new System.ComponentModel.DataAnnotations.ValidationException("Odvozený ukazatel již tento zdroj obsahuje.");
            }

            this.BDBC_SLOUPCE.Add(Sloupec);//Priradim field jako zdroj ukazatele
        }

        /// <summary>
        /// Přidává k odvozenému ukazateli jako zdroj jiný odvozený ukazatel
        /// </summary>
        /// <param name="ZdrojovyOU"></param>
        public void PridejZdrojovyOdvozUkaz(OU_ODVOZ_UKAZ ZdrojovyOU)
        {
            if (this == ZdrojovyOU)
            {
                throw new System.ComponentModel.DataAnnotations.ValidationException("Odvozený ukazatel se shoduje se zdrojovým.");
            }

            if (this.OU_ODVOZ_UKAZ1.Contains(ZdrojovyOU))
            {
                throw new System.ComponentModel.DataAnnotations.ValidationException("Odvozený ukazatel již tento zdroj obsahuje.");
            }

            if (ZdrojovyOU.OU_TAB == this.OU_TAB)//pokud je přidávaný zdroj ze stejné tabulky, kontroluji generaci a pořadí
            {
                //kontrola generace + pořadí
                if (this.GENERACE < ZdrojovyOU.GENERACE)
                {
                    throw new System.ComponentModel.DataAnnotations.ValidationException("Generace přidávaného odvozeného ukazatele je vyšší.");
                }
                if (this.GENERACE == ZdrojovyOU.GENERACE)
                {
                    if (this.PORADI_VYPOCTU < ZdrojovyOU.PORADI_VYPOCTU)
                    {
                        throw new System.ComponentModel.DataAnnotations.ValidationException("Pořadí výpočtu přidávaného odvozeného ukazatele je vyšší.");
                    }
                }
            }
            else if (ZdrojovyOU.OU_TAB.PORADI > this.OU_TAB.PORADI)//pokud má zdrojová tabulka vyšší pořadí výpočtu
            {
                //kontrola generace zdroje musí být nišší
                if (this.GENERACE < ZdrojovyOU.GENERACE)
                {
                    throw new System.ComponentModel.DataAnnotations.ValidationException("Generace přidávaného odvozeného ukazatele je vyšší.");
                }
                //kontrola generace zdroje musí být nišší
                if (this.GENERACE == ZdrojovyOU.GENERACE)
                {
                    throw new System.ComponentModel.DataAnnotations.ValidationException("Pořadí výpočtu tabulky do které patří zdrojový odvozený ukazatele je vyšší než pořadí tabulky upravovaného odvozeného ukazatele. Generaca se nemohou rovnat.");
                }
                //throw new System.ComponentModel.DataAnnotations.ValidationException("Pořadí výpočtu tabulky do které patří přidávaný odvozený ukazatele je vyšší než pořadí tabulky upravovaného odvozeného ukazatele.");
            }
            else if (ZdrojovyOU.OU_TAB.PORADI < this.OU_TAB.PORADI)//pokud má zdrojová tabulka menší pořadí výpočtu
            {
                //kontrola generace zdroje musí být nišší
                if (this.GENERACE < ZdrojovyOU.GENERACE)
                {
                    throw new System.ComponentModel.DataAnnotations.ValidationException("Generace přidávaného odvozeného ukazatele je vyšší.");
                }
            }

            this.OU_ODVOZ_UKAZ1.Add(ZdrojovyOU);
        }

        /// <summary>
        /// Přidává k odvozenému ukazateli jako zdroj objekt bdbdc_primarni_klice
        /// </summary>
        public void PridejBdbcPK(BDBC_PRIMARNI_KLICE PrimKlic)
        {
            if (this.BDBC_PRIMARNI_KLICE.Contains(PrimKlic))
            {
                throw new System.ComponentModel.DataAnnotations.ValidationException("Odvozený ukazatel již tento zdroj obsahuje.");
            }

            this.BDBC_PRIMARNI_KLICE.Add(PrimKlic);
        }

        /// <summary>
        /// Přidává k odvozenému ukazateli jako zdroj objekt ext_sloupce
        /// </summary>
        public void PridejExt(EXT_SLOUPCE sloupec)
        {
            if (this.EXT_SLOUPCE.Contains(sloupec))
            {
                throw new System.ComponentModel.DataAnnotations.ValidationException("Odvozený ukazatel již tento zdroj obsahuje.");
            }

            this.EXT_SLOUPCE.Add(sloupec);
        }

        public void PridejCisel()
        {
            throw new NotImplementedException("Není hotové.");
        }

        #endregion Zdroje


        #region NEPOUŽITÉ kontroly shodnosti PK

        ///// <summary>
        ///// Rekurzivní kontrola všech zdrojů z bdbc ve všech odvozených ukazatelech, které jsou zdrojové
        ///// </summary>
        ///// <param name="OdvozUkaz"></param>
        //private void RekurzivniKontrolaPodrizenychZdrojuOU(OU_ODVOZ_UKAZ OdvozUkaz)
        //{
        //    foreach (OU_ODVOZ_UKAZ ouPodrizeny in OdvozUkaz.OU_ODVOZ_UKAZ1)
        //    {

        //        foreach (BDBC_SLOUPCE BDBCZdroj in ouPodrizeny.BDBC_SLOUPCE)
        //            KontrolaBDBCZdroje(BDBCZdroj, this.OU_TAB);

        //        RekurzivniKontrolaPodrizenychZdrojuOU(ouPodrizeny);
        //    }
        //}

        ///// <summary>
        ///// Rekurzivní kontrola bdbc zdroje pro všechny odvozené ukazatele do kterých je vložen jako zdroj
        ///// </summary>
        ///// <param name="OdvozUkaz"></param>
        ///// <param name="Sloupec"></param>
        //private void RekurzivniKontrolaNadrazenychZdrojuOU(OU_ODVOZ_UKAZ OdvozUkaz, BDBC_SLOUPCE Sloupec)
        //{
        //    foreach (OU_ODVOZ_UKAZ ouNadrazeny in OdvozUkaz.OU_ODVOZ_UKAZ2)
        //    {

        //        //foreach (BDBC_SLOUPCE BDBCZdroj in ouNadrazeny.BDBC_SLOUPCE)
        //        KontrolaBDBCZdroje(Sloupec, ouNadrazeny.OU_TAB);

        //        RekurzivniKontrolaNadrazenychZdrojuOU(ouNadrazeny, Sloupec);
        //    }
        //}

        ///// <summary>
        ///// Kontrola bdbc zdroje s definicí oudot tabulky
        ///// </summary>
        ///// <param name="Sloupec"></param>
        ///// <param name="Tabulka"></param>
        //private void KontrolaBDBCZdroje(BDBC_SLOUPCE Sloupec, OU_TAB Tabulka)
        //{
        //    //Kontrola shodnosti základního primárního klíče tabulky

        //    var pocetZdroju = (from o in Tabulka.OU_ODVOZ_UKAZ
        //                       where o.BDBC_SLOUPCE.Any()
        //                       select o.BDBC_SLOUPCE).Count();

        //    if (pocetZdroju == 0)
        //    {
        //        //Pokud k tabulce není přiřazen ještě žádný zdrojový field zjistí se zda o jeho původní tabulka obsahuje nějaké základní primarní klíče a přidá je k tabulkce v ou_dotu
        //        if (Sloupec.BDBCPRIRAZENE_FIELDY.BDBCTABULKY.BLOKY_PK > 0) //podmínka zda má zdrojová tabulka nějaký základní primarní klíč navíc
        //        {
        //            //Vloží primarní klíče do tabulku oudotu
        //            string[] pklice = Sloupec.BDBCPRIRAZENE_FIELDY.BDBCTABULKY.JMENA_PK.Split(',');
        //            foreach (string pk in pklice)
        //            {
        //                Tabulka.OU_PRIMARNI_KLICE.Add(new OU_PRIMARNI_KLICE { JMENO = pk.Trim().ToUpper() });
        //            }
        //        }
        //    }
        //    else
        //    {
        //        //Pokud tabulka již nějaké zdroje obsajue provede se kontrola primarního klíče zdroje s klíčem definovaným pro tabulku
        //        //Vložit kontrolu, že se shodují jména sloupců s již vytvořenými
        //        if (Sloupec.BDBCPRIRAZENE_FIELDY.BDBCTABULKY.BLOKY_PK > 0) //podmínka zda má zdrojová tabulka nějaký základní primarní klíč navíc
        //        {
        //            //Kontrola shodnosti základních primarních klíčů
        //            string[] pklice = Sloupec.BDBCPRIRAZENE_FIELDY.BDBCTABULKY.JMENA_PK.Split(',');
        //            if (Tabulka.OU_PRIMARNI_KLICE.Count - 2 != pklice.Length)
        //                throw new Exception("Neshodují se základní primární klíče tabulky s přidávaným fieldem.");
        //            else
        //            {
        //                var x = from p in Tabulka.OU_PRIMARNI_KLICE
        //                        where p.JMENO != "IDOKRES" & p.JMENO != "IDPAGINA"
        //                        select p.JMENO;
        //                foreach (string pk in pklice)
        //                {
        //                    if (!x.Contains(pk.ToUpper()))
        //                    {
        //                        throw new Exception("Neshodují se základní primární klíče tabulky s přidávaným fieldem.");
        //                    }
        //                }

        //            }
        //        }
        //        else
        //        {
        //            //Kontrola zda již k tabulce nejsou přiřazeny základní pk, které tento field neobsahuje
        //            if (Tabulka.OU_PRIMARNI_KLICE.Count != 2)
        //                throw new Exception("Neshodují se základní primární klíče tabulky s přidávaným fieldem.");
        //        }
        //    }
        //}

        #endregion NEPOUŽITÉ kontroly shodnosti PK
    }
}
