﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using OuDot.ServicesOudot;

namespace OuDot.Model
{
    public partial class OU_TAB
    {
        
        /// <summary>
        /// Filtr na název OU v kolekci OU na táto tabululce
        /// </summary>
        public string FilterNazevOUView { get; set; }
        private ICollectionView _viewOU;
        //private ICollectionViewLiveShaping _viewOU;
        /// <summary>
        /// ICollectionView pro kolekci (ObservableCollection) OU v tabulce. View je filtrováno podle názvu OU přes property FilterNazevOUView
        /// </summary>
        public System.ComponentModel.ICollectionView ViewOU
        {
            get 
            {
                _viewOU = System.Windows.Data.CollectionViewSource.GetDefaultView(this.OU_ODVOZ_UKAZ);
                _viewOU.Filter = f =>
                {
                    OU_ODVOZ_UKAZ ou = f as OU_ODVOZ_UKAZ;
                    return ou.NAZEV.ToLower().Contains(FilterNazevOUView == null ? "" : FilterNazevOUView.ToLower());
                };

                
                return _viewOU; 
            }
        }

             
        /// <summary>
        /// Založení nové tabulky
        /// </summary>
        /// <param name="ObdobiTab">Období do kterého zakládám novou tabulku</param>
        public void Pridej(ULOHA_METOD_OBDOBI ObdobiTab)
        {

            this.SQL_VLASTNI_KOD = false;
            this.ULOHA_METOD_OBDOBI = ObdobiTab;
            DBContext.Instance.Entity.OU_TAB.Add(this);
            
            //ObdobiTab.Update();//Potřeba spusti onpropertyChanged na kolekci do které se přidává aby se aktualizovalo menu
        }

        /// <summary>
        /// Automatické založení primárního klíče
        /// </summary>
        internal void GenerujSQLZalozeniPK()
        {
            if (this.SQL_VLASTNI_KOD)
                return;
            else
            {
                //Pokud již tabulka obsahuje sql kód, zobrazím varování o případné ztrátě vlastního textu a případně změnu zruším:
                if (!string.IsNullOrEmpty(this.SQL_GENEROVANI_PK))
                {
                    string zprava = string.Format("Opravdu si přejete vygenerovat automatický sql kód pro založení hodnot primárního klíče?{0}Dojde ke ztrátě vlastního napsaného sql kódu.", Environment.NewLine);
                    MessageBoxResult mbr = MessageBox.Show(zprava, "Generování SQL pro hodnoty PK", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                    if (mbr != MessageBoxResult.Yes)
                    {
                        this.SQL_VLASTNI_KOD = true;
                        return;
                    }
                }

                this.SQL_GENEROVANI_PK = GenerovaniSQL.ZalozeniPK(this, this.BDBCTABULKY);
            }
                
        }

        //Celý objekt to string
        public override string ToString()
        {
            return this.JMENO;
        }

    }
}
