﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace OuDot.ServicesOudot
{
    public class Log
    {
        /// <summary>
        /// Zapsání chyby do log souboru
        /// </summary>
        /// <param name="ex">Výjmka</param>
        internal static void LogException(Exception ex, string MujPopis)
        {
            if (ex.InnerException != null)
            {
                Log.LogException(ex.InnerException, MujPopis);
            }
            else
            {
                LogString(ex.ToString(), MujPopis);
            }
           
        }

        
        /// <summary>
        /// Zapsání chyby do log souboru
        /// </summary>
        /// <param name="Chyba">Popis chyby</param>
        internal static void LogString(String Chyba, string Popis)
        {
            string CestaLog = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"Erorr.log");
            try
            {
                if (!File.Exists(CestaLog))
                {
                   var myErrorLogFile = File.Create(CestaLog);
                   myErrorLogFile.Close();
                }

                if (SouboryPomocne.IsFileLocked(new FileInfo(CestaLog)))
                    throw new Exception("Nelze zavřít soubor Error.log");
                
                using (StreamWriter sw = new StreamWriter(CestaLog, true))
                {
                    sw.WriteLine(String.Format(@"Datum: {0}", DateTime.Now.ToString("dd/MM/yyyy HH:mm:ss")));
                    sw.WriteLine(String.Format(@"Popis: {0}", Popis));
                    sw.WriteLine(String.Format(@"Verze: {0}", Assembly.GetExecutingAssembly().GetName().Version.ToString()));
                    sw.WriteLine(String.Format(@"Chyba: {0}", Chyba));
                    sw.WriteLine(String.Format(@"----------------------------------------------------------------{0}", Environment.NewLine));
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(String.Format(@"Nelze zapsat chybu aplikace do {2}{0}{0}Chyba:{0}  {1} ", Environment.NewLine, ex.Message, CestaLog), "BDBConverter - Zápis do error logu", MessageBoxButton.OK, MessageBoxImage.Error);
                
            }

        }
    }
}
