﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using OuDot.Model;


namespace OuDot.ServicesOudot
{
    public class MetaData
    {

        
        public ULOHA_METOD_OBDOBI ObdobiMetod { get; set; }
        public int CisloRadku { get; set; }

        public MetaData(ULOHA_METOD_OBDOBI Obdobi)
        {
            ObdobiMetod = Obdobi;
            CisloRadku = 0;
        }

        internal void VytvorXlsVystup(string CestaVystup)
        {
            //Vytvoření Excel souboru
            NPOI.HSSF.UserModel.HSSFWorkbook hssfwb = new NPOI.HSSF.UserModel.HSSFWorkbook();
            NPOI.SS.UserModel.ISheet ws = hssfwb.CreateSheet("OuDot meta data");
            
            //Hlavička
            NPOI.SS.UserModel.IRow row = ws.CreateRow(CisloRadku);
            CisloRadku++;
            row.CreateCell(0).SetCellValue("KOD");
            row.CreateCell(1).SetCellValue("HODNOTA");
            row.CreateCell(2).SetCellValue("POPIS");
            row.CreateCell(3).SetCellValue("OTAZKA");

            //Plnění:
            foreach (OU_ODVOZ_UKAZ OdvozUkaz in ObdobiMetod.OU_TAB.SelectMany(o=>o.OU_ODVOZ_UKAZ))
            {
                //Vytvoří nový řádek a posune hodnotu s číslem řádku na další
                NPOI.SS.UserModel.IRow rowOU = ws.CreateRow(CisloRadku);
                CisloRadku++;
                //Vloží hodnoty z odvozeného ukazatele do sloupečků název a popis
                rowOU.CreateCell(0).SetCellValue(OdvozUkaz.NAZEV);
                rowOU.CreateCell(2).SetCellValue(OdvozUkaz.POPIS);
                //Pokud má odvozený ukazatel jeden Blaise zdroj snaží se vložit otázku z tohoto zdroje
                if (OdvozUkaz.BDBC_SLOUPCE.Count() == 1)
                {
                    BDBC_SLOUPCE sloupec = OdvozUkaz.BDBC_SLOUPCE[0];
                    string variable = sloupec.BDBCPRIRAZENE_FIELDY.NAZEV_FIELDU;

                    BDBC_POPISY metaData = sloupec.BDBCPRIRAZENE_FIELDY.BDBCTABULKY.ULOHA_OBDOBI.BDBC_POPISY.Where(p => p.VARIABLE == variable).FirstOrDefault();

                    if (metaData == null)
                    {
                        rowOU.CreateCell(3).SetCellValue("CHYBÍ BDBC METADATA!");
                    }
                    else
                    {
                        rowOU.CreateCell(3).SetCellValue(metaData.WORDING);
                    }
                    
                }
                else
                {
                    rowOU.CreateCell(3).SetCellValue("SLOŽEN Z VÍCE BLAIESE ZDROJŮ, NEBO NEMÁ ŽÁDNÉ BLAISE ZDROJE");
                }
                //Poku má odvozený ukazatel nějké kategorie jsou vloženy
                foreach (OU_CATEGORY cat in OdvozUkaz.OU_CATEGORY)
                {
                    //Vytvoří nový řádek a posune hodnotu s číslem řádku na další
                    NPOI.SS.UserModel.IRow rowC = ws.CreateRow(CisloRadku);
                    CisloRadku++;
                    //jsou vyplněny buňky pro sloupce hodnota a popis
                    rowC.CreateCell(1).SetCellValue((double)cat.HODNOTA);
                    rowC.CreateCell(2).SetCellValue(cat.POPIS);
                }
            }

            //Uložení a uzavření xls souboru
            //System.IO.FileStream file = new System.IO.FileStream(@"d:\Dokumenty\Visual Studio 2013\Projects\OuDot\test.xls", FileMode.Create);
            System.IO.FileStream file = new System.IO.FileStream(CestaVystup, FileMode.Create);
            hssfwb.Write(file);
            file.Close();

            string zprava = string.Format("Katalog {1} odvozených ukazatelů byl úspěšně vytvořen.{0}{0}{2}", Environment.NewLine, Path.GetFileName(CestaVystup), CestaVystup);
            Xceed.Wpf.Toolkit.MessageBox.Show(zprava,"Katalog OU", System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Information);

        }  
    }
}
