﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OuDot.ServicesOudot
{
    public static class SouboryPomocne
    {
        /// <summary>
        /// Otevře formulář pro výběr souboru
        /// </summary>
        /// <param name="soubor">cesta k souboru, která je nastavena</param>
        /// <returns>cestu k souboru *.bmi</returns>
        internal static string VyberSoubor(string soubor, string filter)
        {

            Microsoft.Win32.OpenFileDialog ofd = new Microsoft.Win32.OpenFileDialog();
            ofd.Filter = filter;
            ofd.FilterIndex = 1;
            if (File.Exists(soubor))
                ofd.InitialDirectory = Path.GetDirectoryName(soubor); 
            ofd.FileName = Path.GetFileName(soubor);
            Nullable<bool> result = ofd.ShowDialog();
            if (result == true)
            { return ofd.FileName; }
            else
            { return soubor; }

        }

        internal static string VytvorSoubor(string Soubor, string Filter)
        {
            Microsoft.Win32.SaveFileDialog sfd = new Microsoft.Win32.SaveFileDialog();
            sfd.FileName = Path.GetFileName(Soubor);
            sfd.Filter = Filter;
            sfd.FilterIndex = 1;
            if (File.Exists(Soubor))
                sfd.InitialDirectory = Path.GetDirectoryName(Soubor);

           

            Nullable<bool> result = sfd.ShowDialog();
            if (result == true)
            { return sfd.FileName; }
            else
            { return null; }
        }

        internal static bool IsFileLocked(FileInfo file)
        {
            FileStream stream = null;

            try
            {
                stream = file.Open(FileMode.Open, FileAccess.Read, FileShare.None);
            }
            catch (IOException)
            {
                //the file is unavailable because it is:
                //still being written to
                //or being processed by another thread
                //or does not exist (has already been processed)
                return true;
            }
            finally
            {
                if (stream != null)
                    stream.Close();
            }

            //file is not locked
            return false;
        }
    }
}
