﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using OuDot.ServicesOudot;

namespace OuDot.ViewModel
{
    /// <summary>
    /// Interaction logic for ChybyUserControl.xaml
    /// </summary>
    public partial class ChybyUserControl : UserControl
    {
        public ChybyUserControl()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Zobrazí okno, kde se vyskytuje chyba na kterou dvakrát poklepal
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DataGridRow_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            try
            {
                object vizualizovanaData = ((sender as DataGridRow).Item as ValidacniChyba).DataContextOknaChyby;
                var mw = Application.Current.MainWindow as MainWindow;

                mw.OtevriOknoPodleSendra(vizualizovanaData);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba při zobrazení okna s validační chybou:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Chyby", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            
        }
    }
}
