﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace OuDot.ViewModel
{
    /// <summary>
    /// Interaction logic for LoginWindow.xaml
    /// </summary>
    public partial class LoginWindow : Window, IDisposable
    {
        public bool Prihlasit { get; set; }
        public SecureString Password { get; set; }

        public LoginWindow()
        {
            InitializeComponent();
            
        }

       
        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            Properties.Settings.Default.PrihlasJmeno = TBUserName.Text;
            Properties.Settings.Default.Save();
            if (Prihlasit)
            {
                Password = PBHeslo.SecurePassword;
                this.DialogResult = true;
            }
            else
                this.DialogResult = false;
        }

        private void BPrihlasit_Click(object sender, RoutedEventArgs e)
        {
            Prihlasit = true;
            this.Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            TBUserName.Text = Properties.Settings.Default.PrihlasJmeno;
        }

        #region IDisposable Members
        // Flag: Has Dispose already been called?
        bool disposed = false;

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }


        // Protected implementation of Dispose pattern.

        protected virtual void Dispose(bool disposing)
        {

            if (disposed)
                return;

            if (disposing)
            {

                // Free any other managed objects here.

            }

            // Free any unmanaged objects here.
            disposed = true;

        }
        #endregion
    }
}
