using System.ComponentModel;
using GalaSoft.MvvmLight;
using Oracle.ManagedDataAccess.Client;
using OuDot.Model;
using System.Collections.ObjectModel;
using GalaSoft.MvvmLight.CommandWpf;
using System.Linq;
using System.Collections.Generic;
using System.Data.Entity.Validation;
using System.Data.Entity.Infrastructure;
using System;
using System.Windows;
using System.Data.Entity;
using System.Collections;
using OuDot.ServicesOudot;
using OuDot.RozsireniGrafika;
using System.Windows.Threading;
using System.IO;
using System.Diagnostics;
using OuDot.Properties;
using OuDot.ViewModel.PomocnaOkna;
using System.Threading.Tasks;
using System.Data;
using System.Text.RegularExpressions;
using Novacode;
using System.Text;
using OuDot.ViewModel.IporterWizzard;
using System.Threading;

namespace OuDot.ViewModel
{
    /// <summary>
    /// This class contains properties that the main View can data bind to.
    /// <para>
    /// Use the <strong>mvvminpc</strong> snippet to add bindable properties to this ViewModel.
    /// </para>
    /// <para>
    /// You can also use Blend to data bind with the tool's support.
    /// </para>
    /// <para>
    /// See http://www.galasoft.ch/mvvm
    /// </para>
    /// </summary>
    public class MainViewModel : ViewModelBase
    {
        #region Property
        /// <summary>
        /// Singlton pro model z Ora DB
        /// </summary>
        public DBContext MyDBContext { get; set; }
        /// <summary>
        /// Slou k aktualizaci programu, kontroluje zda je na J:CAPI novje verze OUdotu
        /// </summary>
        private BackgroundWorker bgwKontrolaVerzi;
        /// <summary>
        /// Cesta k xls souboru smeta daty odvozench ukazatel
        /// </summary>
        public string KatalogXlsCesta { get; set; }

        #region Binding Property

        //private ULOHA_METOD _ulohaMetod;
        ///// <summary>
        ///// Vybran metodick loha
        ///// </summary>
        //public ULOHA_METOD UlohaMetod
        //{
        //    get { return _ulohaMetod; }
        //    set
        //    {
        //        if (_ulohaMetod != value)
        //        {
        //            _ulohaMetod = value;
        //            OnPropertyChanged();

        //        }
        //    }
        //}


        //private ObservableCollection<ULOHA_METOD> _ulohyMetod;
        ///// <summary>
        ///// Kolekce vech metodickch loh
        ///// </summary>
        //public ObservableCollection<ULOHA_METOD> UlohyMetod
        //{
        //    get { return _ulohyMetod; }
        //    set
        //    {
        //        if (_ulohyMetod != value)
        //        {
        //            _ulohyMetod = value;
        //            OnPropertyChanged();
        //        }
        //    }
        //}


        private ULOHA_METOD_OBDOBI _obdobiMetod;

        public ULOHA_METOD_OBDOBI ObdobiMetod
        {
            get { return _obdobiMetod; }
            set
            {
                if (_obdobiMetod != value)
                {
                    _obdobiMetod = value;
                    OnPropertyChanged();
                }
            }
        }


        private OU_TAB _tabulka;

        public OU_TAB Tabulka
        {
            get { return _tabulka; }
            set
            {
                if (_tabulka != value)
                {
                    _tabulka = value;
                    OnPropertyChanged();

                    //Pokud je vybran tabulka sead ve OU, kter obsahuje podle kd piazench tmat
                    SortOUTema(null);
                    
                }
            }
        }



        private ULOHA_OBDOBI _obdobiTeren;

        public ULOHA_OBDOBI ObdobiTeren
        {
            get { return _obdobiTeren; }
            set
            {
                if (_obdobiTeren != value)
                {
                    _obdobiTeren = value;
                    OnPropertyChanged();
                }
            }
        }


        private string _filterOUText;
        /// <summary>
        /// Filtr pro treeView na nzvy OU
        /// </summary>
        public string FilterOUText
        {
            get { return _filterOUText; }
            set
            {
                if (_filterOUText != value)
                {
                    _filterOUText = value;
                    OnPropertyChanged();

                    //var tabs = UlohaMetod.ULOHA_METOD_OBDOBI.SelectMany(o => o.OU_TAB);
                    foreach (var tab in ObdobiMetod.OU_TAB)
                    {
                        tab.FilterNazevOUView = FilterOUText;
                        tab.ViewOU.Refresh();
                    }

                }
            }
        }


        private bool _isBusy;
        /// <summary>
        /// Zna, e probh akce na pozad programu
        /// </summary>
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged();
                }
            }
        }


        private bool _provadiVypocet;

        public bool ProvadiVypocet

        {
            get { return _provadiVypocet; }
            set
            {
                if (_provadiVypocet != value)
                {
                    _provadiVypocet = value;
                    OnPropertyChanged();
                }
            }
        }

        public CancellationTokenSource CTSPrerusitVypocet { get; set; }

        private bool _isConnectionLost;

        public bool IsConnectionLost
        {
            get { return _isConnectionLost; }
            set
            {
                if (_isConnectionLost != value)
                {
                    _isConnectionLost = value;
                    OnPropertyChanged();
                }
            }
        }



        private bool _isChybyVisible;

        public bool IsChybyVisible
        {
            get { return _isChybyVisible; }
            set
            {
                if (_isChybyVisible != value)
                {
                    _isChybyVisible = value;
                    OnPropertyChanged();
                }
            }
        }


        private ObservableCollection<EXT_SLOUPCE> _externiZdroje;
        /// <summary>
        /// Obsahuje vechny dostupn extern zdroje
        /// </summary>
        public ObservableCollection<EXT_SLOUPCE> ExterniZdroje

        {
            get { return _externiZdroje; }
            set
            {
                if (_externiZdroje != value)
                {
                    _externiZdroje = value;
                    OnPropertyChanged();
                }
            }
        }


        #endregion Binding Property
        #region Commands

        public RelayCommand NovaTabCommand { get; private set; }
        public RelayCommand UlozitCommand { get; private set; }
        public RelayCommand NovyOUCommand { get; private set; }
        public RelayCommand<ULOHA_METOD_OBDOBI> VypisXlsCommand { get; private set; }
        //public RelayCommand WindowLoadedCommand { get; private set; }
        public RelayCommand<object> SmazatTabulkuCommand { get; private set; }
        public RelayCommand<object> SmazatOdvozUkazCommand { get; private set; }
        public RelayCommand<object> SpocitatObdobiCommand { get; private set; }
        public RelayCommand OProgramuButtonCommand { get; private set; }
        public RelayCommand NapovedaCommand { get; private set; }
        public RelayCommand PregenerujSQLCommand { get; private set; }
        public RelayCommand<object> WindowClosingCommand { get; private set; }
        public RelayCommand NastaveniCommand { get; private set; }
        public RelayCommand<object> KlonovatOUCommand { get; private set; }
        public RelayCommand ImportExtCommand { get; private set; }
        public RelayCommand<object> SpocitatOUCommand { get; private set; }
        public RelayCommand KlonovatDoJineTabOUCommand { get; private set; }
        public RelayCommand PresunOUCommand { get; private set; }
        public RelayCommand VytvoritKatalogOUCommand { get; private set; }
        public RelayCommand VytvoritOraVystupCommand { get; private set; }
        public RelayCommand<System.Windows.Controls.DataGrid> SortOUTemaCommand { get; private set; }
        public RelayCommand PrerusitVypocetCommand { get; private set; }

        public RelayCommand TestCommand { get; private set; }

        #endregion Commands

        #endregion Property
        #region Udlosti
        /// <summary>
        /// Otvr nov okno Tabulky nebo OU
        /// </summary>
        public event EventHandler OtvritNoveOkno;

        public event EventHandler ZavritOkno;
        #endregion Udlosti


        /// <summary>
        /// Initializes a new instance of the MainViewModel class.
        /// </summary>
        public MainViewModel()
        {
            if (DesignerProperties.GetIsInDesignMode(new System.Windows.DependencyObject()))
            {

                // Code runs in Blend --> create design time data.





            }
            else
            {
                // Code runs "for real"

                MyDBContext = DBContext.Instance;

                System.Net.NetworkInformation.NetworkChange.NetworkAvailabilityChanged += NetworkChange_NetworkAvailabilityChanged;//Zmna dostupnosti pipojen k sti

                NovaTabCommand = new RelayCommand(() => NovaTab());
                UlozitCommand = new RelayCommand(() => UlozitAsync());
                NovyOUCommand = new RelayCommand(() => NovyOU());
                VypisXlsCommand = new RelayCommand<ULOHA_METOD_OBDOBI>((p) => VypisXls(p));
                //WindowLoadedCommand = new RelayCommand(() => WindowLoaded());

                SmazatOdvozUkazCommand = new RelayCommand<object>((o) => SmazatOdvozUkaz(o));
                SpocitatObdobiCommand = new RelayCommand<object>((o) => SpocitatObdobi(o.ToString()));
                OProgramuButtonCommand = new RelayCommand(() => OProgramuButton());
                NapovedaCommand = new RelayCommand(() => Napoveda());
                PregenerujSQLCommand = new RelayCommand(() => PregenerujSQL());
                WindowClosingCommand = new RelayCommand<object>((p) => WindowClosing(p));
                NastaveniCommand = new RelayCommand(() => Nastaveni());
                KlonovatOUCommand = new RelayCommand<object>((o) => KlonovatOU(o));
                ImportExtCommand = new RelayCommand(() => ImportExt());
                SpocitatOUCommand = new RelayCommand<object>((o) => SpocitatOU(o));
                KlonovatDoJineTabOUCommand = new RelayCommand(() => KlonovatDoJineTabOU());
                PresunOUCommand = new RelayCommand(() => PresunOU());
                VytvoritKatalogOUCommand = new RelayCommand(() => VytvoritKatalogOU());
                VytvoritOraVystupCommand = new RelayCommand(() => VytvoritOraVystup());
                SortOUTemaCommand = new RelayCommand<System.Windows.Controls.DataGrid>((o) => SortOUTema(o));
                PrerusitVypocetCommand = new RelayCommand(() => PrerusitVypocet());

                TestCommand = new RelayCommand(() => Test());


                try
                {
                    //Nate heslo ze souboru
                    string cestaPass = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), @"OuDot_data.pw");
                    if (!File.Exists(cestaPass))//Pokud neexistuje mj pihlaovac soubor zobrazuji logovac okno
                    {
                        bool neuspesnyLogin = true;
                        do
                        {
                            using (LoginWindow lw = new LoginWindow())
                            {
                                //lw.Owner = Application.Current.MainWindow;//nastaven ownera z dvodu nedostupnosti hlavnho okna pokud je sputno okno//NENASTAVOVAT OKNO JET NEEXISTUJE
                                //zobrazen logovacho okna a pokud se chce pihlsit naten dat, pokud ne zaven aplikace
                                if (lw.ShowDialog() == true)
                                {

                                    //oven pihlaovac daj otestovan pipojen do db a natenm dat z db
                                    neuspesnyLogin = !MyDBContext.PripojitKdb(lw.PBHeslo.Password, Properties.Settings.Default.PrihlasJmeno);

                                    //TOKEN Pro Tu nebo setdom:
                                    //if (Properties.Settings.Default.PrihlasJmeno.ToUpper() == "DVORNAKOVA" || Properties.Settings.Default.PrihlasJmeno.ToUpper() == "SETDOM")
                                    //{
                                    //    Krypt.Heslo t = new Krypt.Heslo();
                                    //    t.UlozHeslo(Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), @"OuDot_data.pw"), lw.PBHeslo.Password);
                                    //}


                                }
                                else
                                {
                                    Application.Current.Shutdown();
                                    return;
                                }
                            }

                        } while (neuspesnyLogin);//Zobrazuji Login dokud nen uspn
                    }
                    else
                    {
                        //Naten z mho logovacho souboru
                        Krypt.Heslo h = new Krypt.Heslo();
                        string p = h.NactiHeslo(cestaPass);
                        h.Dispose();
                        if (Properties.Settings.Default.PrihlasJmeno.ToUpper() == "DVORNAKOVA")
                            MyDBContext.PripojitKdb(p, Properties.Settings.Default.PrihlasJmeno);
                        else
                            MyDBContext.PripojitKdb(p, "setdom");
                        p = null;
                    }

                    //UlohyMetod = new ObservableCollection<ULOHA_METOD>(MyDBContext.Entity.ULOHA_METOD);
                    //UlohaMetod = MyDBContext.Entity.ULOHA_METOD.Find("TEST");

                    ObdobiTeren = DBContext.Instance.Entity.ULOHA_OBDOBI.Find(Settings.Default.IdTerenUlohaObd);
                    ObdobiMetod = DBContext.Instance.Entity.ULOHA_METOD_OBDOBI.Find(Settings.Default.IdMetodObdobi);
                    //Pokud nebylo nalezeno jedno z obdob spustm okno pro vbr
                    if (ObdobiTeren == null || ObdobiMetod == null)
                    {
                        Nastaveni();
                    }

                    Tabulka = ObdobiMetod.OU_TAB.Where(t => t.ID == Settings.Default.IdOU_TAB).FirstOrDefault();

                    //Ke kad tabulce v OUdotu pidm udlost na zmnu kolekce OU, kter obsahuj. Pi kad zmn kolekce pot obnovuji obdob, kter obsahuje vechny OU zdroje
                    foreach (var tab in ObdobiMetod.OU_TAB)
                    {
                        tab.OU_ODVOZ_UKAZ.CollectionChanged += TabulkaOU_ODVOZ_UKAZ_CollectionChanged;
                    }
                    //Pidn handleru pi zmn kolekce tabulek v obdob
                    ObdobiMetod.OU_TAB.CollectionChanged += ObdobiOU_TAB_CollectionChanged;

                    //Naten externch zdroj
                    ExterniZdroje = new ObservableCollection<EXT_SLOUPCE>(DBContext.Instance.Entity.EXT_SLOUPCE);
                    NastaveniFiltruExtZdroje();

                    

                    
                }
                catch (Exception ex)
                {
                    string zprava = string.Format("Chyba naten hlavnho okna:{0}{0}{1}", Environment.NewLine, ex.Message);
                    MessageBox.Show(zprava, "Naten hlavnho okna", MessageBoxButton.OK, MessageBoxImage.Error);
                    Application.Current.Shutdown();
                }

                //Automatick aktualizace
                bgwKontrolaVerzi = new BackgroundWorker();
                bgwKontrolaVerzi.DoWork += bgwKontrolaVerzi_DoWork;
                bgwKontrolaVerzi.RunWorkerCompleted += bgwKontrolaVerzi_RunWorkerCompleted;
                bgwKontrolaVerzi.RunWorkerAsync();

                //pok dokud se nezkontroluje prvn aktualizace 
                while (!bgwKontrolaVerzi.IsBusy)
                {
                    System.Threading.Tasks.Task.Delay(100);
                }
            }




        }

        

        internal void Test()
        {
            
        }

        

        /// <summary>
        /// Vytvo Word dokument se seznamem OU
        /// https://docx.codeplex.com/
        /// </summary>
        internal void VytvoritKatalogOU()
        {

            try
            {

                string fileName = SouboryPomocne.VytvorSoubor("", "Word (.docx)|*.docx|All Files (*.*)|*.*");
                if (fileName == null)
                    return;

                var doc = DocX.Create(fileName);// Create the document in memory


                string headlineText = string.Format("{0} {1} - {2}", ObdobiMetod.ID_ULOHA, ObdobiMetod.OBDOBI.Substring(0, 4), ObdobiMetod.ULOHA_METOD.DLOUHY_NAZEV);//z obdob vyberu pouze rok
                // A formatting object for our headline:
                var headLineFormat = new Formatting();
                headLineFormat.FontFamily = new System.Drawing.FontFamily("Calibri");
                headLineFormat.Size = 14;
                Paragraph headLineParagraph = doc.InsertParagraph(headlineText, false, headLineFormat);
                headLineParagraph.SpacingAfter(10);

                foreach (var tab in ObdobiMetod.OU_TAB.OrderBy(t => t.PORADI))
                {
                    
                    //doc.InsertParagraph(tab.JMENO, false, tabFormat);
                    Paragraph tabParagraph = doc.InsertParagraph();
                    tabParagraph.Append(tab.JMENO + " - " + tab.POPIS).Bold();
                    tabParagraph.FontSize(13);
                    tabParagraph.Alignment = Alignment.center;
                    tabParagraph.Font(new System.Drawing.FontFamily("Calibri"));
                    tabParagraph.SpacingAfter(10);
                    //ODSAZEN DALHO DKU:
                    //tabParagraph.IndentationHanging = 3f;//nefunguje destin slo
                    //tabParagraph.IndentationBefore = 3;


                    //TMATA:
                    var serazeneTemata = DBContext.Instance.Entity.OU_TEMATA.Where(t => t.ULOHA_ID == tab.ULOHA_METOD_OBDOBI.ID_ULOHA).ToList();
                    serazeneTemata.Sort((klas1, klas2) => ExtensionMethods.RazeniKlasifikace(klas1.KOD, klas2.KOD));//seadm tmata podle jejich kdu
                    foreach (var tema in serazeneTemata)
                    {
                        //Vyberu vechny OU pro dan tma a vechny jeho podtmata z dan tabulky
                        var allOUTema = tab.OU_ODVOZ_UKAZ.Where(o => o.OU_TEMATA != null && o.OU_TEMATA.KOD.StartsWith(tema.KOD));
                        if (!allOUTema.Any())//pokud tma a ani jeho podtmata neobsahuj OU peskakuji ho a pechzm dal tma
                        {
                            continue;
                        }

                        var odvozUkaz = tab.OU_ODVOZ_UKAZ.Where(o => o.OU_TEMATA == tema).OrderBy(o => o.GENERACE).ThenBy(o => o.PORADI_VYPOCTU);//seadit podle generace a poad vpotu
                        

                        Paragraph temaPar = doc.InsertParagraph();
                        temaPar.Append(tema.ToString()).Bold();
                        temaPar.FontSize(12);
                        temaPar.Font(new System.Drawing.FontFamily("Calibri"));
                        temaPar.SpacingAfter(10);
                        temaPar.UnderlineStyle(UnderlineStyle.singleLine);
                        temaPar.KeepWithNext();//svu s nsledujcm dkem, aby se tma neobjevilo samotn na konci strnky
                    
                        //ODVOZEN UKAZATELE PRO DAN TMA:
                        
                        foreach (var ou in odvozUkaz)
                        {
                            Paragraph ouPar = doc.InsertParagraph();
                            ouPar.FontSize(11);
                            ouPar.Font(new System.Drawing.FontFamily("Calibri"));
                            ouPar.SpacingAfter(10);
                            //ouPar.IndentationBefore = 1; Odsazen 1cm

                            ouPar.Append(ou.NAZEV).Bold();
                            if (!string.IsNullOrEmpty(ou.NAZEV_EU))//Pokud obsahuje nzev eu vlom ho za nzav do zvorky
                            {
                                ouPar.Append(" (").Bold().Append(ou.NAZEV_EU).Italic().Bold().Append(")").Bold();
                            }
                            ouPar.Append(" - " + ou.POPIS);
                            if (!string.IsNullOrEmpty(ou.POPIS_EU))//pokud m popis eu vlom ho 
                            {
                                ouPar.Append(" (").Append(ou.POPIS_EU).Italic().Append(")");
                            }

                            var serazeneKategorie = ou.OU_CATEGORY.OrderBy(c => c.HODNOTA);//seadm kategorie podle hodnoty
                            if (serazeneKategorie.Any())//Kontroluji jestli obsahuje kategorii pokud ne nezakldm odstavec
                            {
                                //Pokud obsahuje kategorie, neodsazuji odstavec OU + svu s nsledujcm odstavcem
                                ouPar.SpacingAfter(0);
                                ouPar.KeepWithNext();

                                Paragraph catPar = doc.InsertParagraph();
                                catPar.FontSize(11);
                                catPar.Font(new System.Drawing.FontFamily("Calibri"));
                                catPar.SpacingAfter(10);
                                catPar.IndentationBefore = 1;
                                catPar.KeepLinesTogether();

                                //var x = doc.AddList(null,);
                                foreach (var cat in serazeneKategorie)
                                {
                                    catPar.Append(string.Format("{0} \t {1}", cat.HODNOTA, cat.POPIS, Environment.NewLine));
                                    if (!string.IsNullOrEmpty(cat.POPIS_EU))//pokud obsahuje popis eu kategorie vlom ho
                                    {
                                        catPar.Append(" (").Append(cat.POPIS_EU).Italic().Append(")");
                                    }
                                    catPar.AppendLine();

                                    //StringBuilder textCat = new StringBuilder(cat.POPIS);
                                    //if (!string.IsNullOrEmpty(cat.POPIS_EU))//pokud obsahuje popis eu kategorie vlom ho
                                    //{
                                    //    textCat.Append(" (<i>" + cat.POPIS_EU + "</i>)");
                                    //}
                                    //doc.AddListItem(x, textCat.ToString(), 0, ListItemType.Numbered, (int)cat.HODNOTA, true, false);

                                }
                                //doc.InsertList(x);
                                

                            }

                        }

                    }

                    //VLOM OU KTER NEMAJ DN TMA:
                    var ouBezTema = tab.OU_ODVOZ_UKAZ.Where(o => o.OU_TEMATA == null).OrderBy(o => o.GENERACE).ThenBy(o => o.PORADI_VYPOCTU);//seadit podle generace a poad vpotu
                    if (ouBezTema.Any())
                    {
                        Paragraph temaPar = doc.InsertParagraph();
                        temaPar.Append("NEZAAZEN").Bold();
                        temaPar.FontSize(11);
                        temaPar.Font(new System.Drawing.FontFamily("Calibri"));
                        temaPar.SpacingAfter(10);

                        foreach (var ou in ouBezTema)
                        {
                            Paragraph ouPar = doc.InsertParagraph();
                            ouPar.FontSize(11);
                            ouPar.Font(new System.Drawing.FontFamily("Calibri"));
                            ouPar.SpacingAfter(10);
                            ouPar.IndentationBefore = 1;

                            ouPar.Append(ou.NAZEV).Bold();
                            if (!string.IsNullOrEmpty(ou.NAZEV_EU))//Pokud obsahuje nzev eu vlom ho za nzav do zvorky
                            {
                                ouPar.Append(string.Format(" ({0})", ou.NAZEV_EU));
                            }
                            ouPar.Append(" - " + ou.POPIS);
                            if (!string.IsNullOrEmpty(ou.POPIS_EU))//pokud m popis eu vlom ho 
                            {
                                ouPar.Append(string.Format(", {0}", ou.POPIS_EU));
                            }

                            var serazeneKategorie = ou.OU_CATEGORY.OrderBy(c => c.HODNOTA);//seadm kategorie podle hodnoty
                            if (serazeneKategorie.Any())//Kontroluji jestli obsahuje kategorii pokud ne nezakldm odstavec
                            {
                                Paragraph catPar = doc.InsertParagraph();
                                catPar.FontSize(11);
                                catPar.Font(new System.Drawing.FontFamily("Calibri"));
                                catPar.SpacingAfter(10);
                                catPar.IndentationBefore = 2;
                                foreach (var cat in serazeneKategorie)
                                {
                                    catPar.Append(string.Format("{0} {1}", cat.HODNOTA, cat.POPIS));
                                    if (!string.IsNullOrEmpty(cat.POPIS_EU))//pokud obsahuje popis eu kategorie vlom ho
                                    {
                                        catPar.Append(string.Format(", {0}", cat.POPIS_EU));
                                    }
                                    catPar.AppendLine();
                                }
                            }
                        }
                    }

                    doc.InsertSectionPageBreak();//vlo konec strnky za tabulkou

                }

                // Save to the output directory:
                doc.Save();

                // Open in Word:
                ProcessStartInfo psi = new ProcessStartInfo("WINWORD.EXE", "\"" + fileName + "\"" );
                psi.UseShellExecute = true;
                Process.Start(psi);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi vytven katalogu odvozench ukazatel:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Katalog ou", MessageBoxButton.OK, MessageBoxImage.Error);
            }
           
            
        }

        

        internal void Nastaveni()
        {
            try
            {
                if (!Ulozit())//Probhne uloen s chybou nelze pokraovat
                {
                    return;
                }

                //Zavt vechny okna:
                if(ZavritOkno!=null)
                    ZavritOkno.Invoke(null, null);

                NastaveniWindow nw = new NastaveniWindow();
                nw.ShowDialog();
                
                ObdobiTeren = DBContext.Instance.Entity.ULOHA_OBDOBI.Find(Settings.Default.IdTerenUlohaObd);
                ObdobiMetod = DBContext.Instance.Entity.ULOHA_METOD_OBDOBI.Find(Settings.Default.IdMetodObdobi);

                //Ke kad tabulce v OUdotu pidm udlost na zmnu kolekce OU, kter obsahuj. Pi kad zmn kolekce pot obnovuji obdob, kter obsahuje vechny OU zdroje
                foreach (var tab in ObdobiMetod.OU_TAB)
                {
                    tab.OU_ODVOZ_UKAZ.CollectionChanged += TabulkaOU_ODVOZ_UKAZ_CollectionChanged;
                }
                //Pidn handleru pi zmn kolekce tabulek v obdob
                ObdobiMetod.OU_TAB.CollectionChanged += ObdobiOU_TAB_CollectionChanged;
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Nelze otevt nastaven.{0}{0}Chyba:{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Nastaven", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }



        #region Window actions
        /// <summary>
        /// Udlost Loaded hlacnho okna => PAD NA WIN 10, PROBLM S VLKNY
        /// </summary>
        //private void WindowLoaded()
        //{

        //    try
        //    {
        //        //Nate heslo ze souboru
        //        string cestaPass = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), @"OuDot_data.pw");
        //        if (!File.Exists(cestaPass))//Pokud neexistuje mj pihlaovac soubor zobrazuji logovac okno
        //        {
        //            bool neuspesnyLogin = true;
        //            do
        //            {
        //                using (LoginWindow lw = new LoginWindow())
        //                {
        //                    lw.Owner = Application.Current.MainWindow;//nastaven ownera z dvodu nedostupnosti hlavnho okna pokud je sputno okno
        //                    //zobrazen logovacho okna a pokud se chce pihlsit naten dat, pokud ne zaven aplikace
        //                    if (lw.ShowDialog() == true)
        //                    {

        //                        //oven pihlaovac daj otestovan pipojen do db a natenm dat z db
        //                        neuspesnyLogin = !MyDBContext.PripojitKdb(lw.PBHeslo.Password, Properties.Settings.Default.PrihlasJmeno);
        //                    }
        //                    else
        //                    {
        //                        Application.Current.Shutdown();
        //                        return;
        //                    }
        //                }

        //            } while (neuspesnyLogin);//Zobrazuji Login dokud nen uspn
        //        }
        //        else
        //        {
        //            //Naten z mho logovacho souboru
        //            Krypt.Heslo h = new Krypt.Heslo();
        //            string p = h.NactiHeslo(cestaPass);
        //            h.Dispose();
        //            MyDBContext.PripojitKdb(p, "setdom");
        //            p = null;
        //        }

        //        UlohyMetod = new ObservableCollection<ULOHA_METOD>(MyDBContext.Entity.ULOHA_METOD);
        //        UlohaMetod = MyDBContext.Entity.ULOHA_METOD.Find("TEST");



        //    }
        //    catch (Exception ex)
        //    {
        //        string zprava = string.Format("Chyba naten hlavnho okna:{0}{0}{1}", Environment.NewLine, ex.Message);
        //        MessageBox.Show(zprava, "Naten hlavnho okna", MessageBoxButton.OK, MessageBoxImage.Error);
        //        Application.Current.Shutdown();
        //    }

        //    //Automatick aktualizace
        //    bgwKontrolaVerzi = new BackgroundWorker();
        //    bgwKontrolaVerzi.DoWork += bgwKontrolaVerzi_DoWork;
        //    bgwKontrolaVerzi.RunWorkerCompleted += bgwKontrolaVerzi_RunWorkerCompleted;
        //    bgwKontrolaVerzi.RunWorkerAsync();

        //    //pok dokud se nezkontroluje prvn aktualizace 
        //    while (!bgwKontrolaVerzi.IsBusy)
        //    {
        //        System.Threading.Tasks.Task.Delay(100);
        //    }

        //}

        /// <summary>
        /// Udlost zaven hlavnho okna
        /// </summary>
        private void WindowClosing(object p)
        {

            CancelEventArgs e = p as CancelEventArgs;

            //Ukldn pi zaven hl. okna
            if (DBContext.Instance.Entity.ChangeTracker.HasChanges() && !IsConnectionLost)//zjist zda jsou njak neuloen zmny a funguje pipojen k sti
            {
                string hlaska = string.Format("Nebyly uloeny posledn proveden zmny. Pokud nebudou uloeny, data budou ztracena.{0}{0}Chcete zmny uloit?", Environment.NewLine);
                var result = MessageBox.Show(hlaska, "Uloit zmny", MessageBoxButton.YesNo, MessageBoxImage.Question);
                if (result == MessageBoxResult.Yes)
                {
                    try
                    {
                        if (Validace.ValidacniChyby.Count > 0)
                        {
                            //Zobrazim chyby:
                            OtvritNoveOkno.Invoke(Validace.ValidacniChyby, null);
                            MessageBox.Show("Byly zjjitny chyby pi validaci. Zmny nebudou uloeny.");
                            e.Cancel = true;
                            return;
                        }

                        DBContext.Instance.Entity.SaveChanges();
                    }
                    catch (Exception ex)
                    {
                        string zprava = string.Format("Posledn zmny nelze uloit.{0}Chyba:{0}{0}{1}", Environment.NewLine, Services.ExceptionsText(ex));
                        MessageBox.Show(zprava, "Uloit zmny", MessageBoxButton.OK, MessageBoxImage.Error);
                        e.Cancel = true;
                    }

                }
            }

            //Uloen do Settings:
            if (Tabulka != null)
                Settings.Default.IdOU_TAB = Tabulka.ID;

            Settings.Default.Save();

        }

        #endregion Window actions

        #region Prce s db contextem
        /// <summary>
        /// Pegeneruje SQL kdy ve vech OU ve vybran loze
        /// </summary>
        internal void PregenerujSQL()
        {
            try
            {
                //Oven e mohu pegenerovat sql
                string cestaPass = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), @"OuDot_data.pw");
                if (File.Exists(cestaPass))
                {
                    //Naten z mho logovacho souboru
                    Krypt.Heslo h = new Krypt.Heslo();
                    string p = h.NactiHeslo(cestaPass);
                    if (!MyDBContext.Entity.Database.Connection.ConnectionString.Contains(p))
                    {
                        MessageBox.Show("Chyba poven. Nelze pegenerovat SQL kdy.", "Pegenerovan SQL", MessageBoxButton.OK, MessageBoxImage.Error);
                        return;
                    }
                    h.Dispose();
                    p = null;
                }
                else
                {
                    MessageBox.Show("Chyba poven. Nelze pegenerovat SQL kdy.", "Pegenerovan SQL", MessageBoxButton.OK, MessageBoxImage.Error);
                    return;
                }


                foreach (var tab in ObdobiMetod.OU_TAB)
                {
                    //if (tab.JMENO != "ZP151_OU_PCR")
                    //    continue;

                    foreach (var ou in tab.OU_ODVOZ_UKAZ)
                    {
                        try
                        {
                            if (ou.OU_FUNKCE.ID != 1)//Pokud je funkce vlastn nepegenerovvm sql kd
                            {
                                //GenerovaniSQL.AutoPregenerovaniSQL = true;
                                ou.SQL_DOTAZ = GenerovaniSQL.GenerujSQL(ou, ou.OU_FUNKCE);
                                //GenerovaniSQL.AutoPregenerovaniSQL = false;
                            }
                            //else
                            //{
                            //    OtvritNoveOkno.Invoke(ou, null);
                            //}

                        }
                        catch (Exception ex)
                        {
                            string zprava = string.Format("Chyba pi generovn SQL kdu pro ou:{0} {1} s generovanou funkc {2}{0}Uloeno v obdob {3} v tabulce {4}{0}{0}", Environment.NewLine, ou.NAZEV, ou.OU_FUNKCE.NAZEV, ObdobiMetod.OBDOBI, tab.JMENO, ex.Message);
                            MessageBox.Show(zprava, "Pegenerovn SQL", MessageBoxButton.OK, MessageBoxImage.Error);
                            throw;
                        }
                    }

                }
            }
            catch (Exception)
            {
                string zprava = string.Format("Pegenerovn bylo ukoneno.");
                MessageBox.Show(zprava, "Pegenerovn SQL", MessageBoxButton.OK, MessageBoxImage.Error);
                //throw;

            }

            MessageBox.Show("Hotovo", "Pregen", MessageBoxButton.OK, MessageBoxImage.Information);

        }

        #region Obdob

        /// <summary>
        /// Spust okno pro definic view v Oracle
        /// </summary>
        internal void VytvoritOraVystup()
        {
            //Upozornnn ped vytvoen vstupu je nutn, aby ji vybran OU byly vypotan
            var result = MessageBox.Show($"Ped vytvoen vstupu je nutn, aby odvozen ukazatele do nj zaazen byly ji vypoteny.\n\nPejete si pokraovat?","Vytvoen vstupu", MessageBoxButton.OKCancel, MessageBoxImage.Question);
            if (result != MessageBoxResult.OK)
                return;

            Knihovnik.VystupyDefiniceWindow vdw = new Knihovnik.VystupyDefiniceWindow();
            vdw.ShowDialog();
            //Odstranm veker vbry u objekt OU
            var vybraneOU = ObdobiMetod.VsechnyOdvozUkaz.Where(o => o.Vyber);
            foreach (var ou in vybraneOU)
            {
                ou.Vyber = false;
            }
        }

        /// <summary>
        /// Vypot vechny OU v obdob
        /// </summary>
        /// <param name="Obdobi"></param>
        internal async void SpocitatObdobi(string Vyber)
        {
            IsBusy = true;
            ProvadiVypocet = true;
            try
            {
                CTSPrerusitVypocet = new CancellationTokenSource();

                await Task.Run(() =>
                     {
                         if (Vyber == "Obdobi")
                         {
                             Services.SpocitejOdvozUkaz(ObdobiMetod, CTSPrerusitVypocet.Token);
                         }

                         if (Vyber == "Tabulka")
                         {
                             //Services.DropTables(new OU_TAB[]{Tabulka}, MyDBContext.OUdotConn);
                             Services.KontrolaAVytvoreniOracleTabulek(MyDBContext.OUdotConn, ObdobiMetod.OU_TAB, new OU_TAB[] { Tabulka });
                             Services.PocitejTabulku(MyDBContext.OUdotConn, Tabulka, CTSPrerusitVypocet.Token);
                         }
                     }, CTSPrerusitVypocet.Token);

            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba vpotu:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Vpoet obdob", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            finally
            {
                IsBusy = false;
                ProvadiVypocet = false;
            }

        }

        /// <summary>
        /// Peru vpoet odvozench ukazatel
        /// </summary>
        internal void PrerusitVypocet()
        {
            CTSPrerusitVypocet.Cancel();
        }

        /// <summary>
        /// Vpis meta dat do xls
        /// </summary>
        /// <param name="MetodObdobi"></param>
        internal void VypisXls(ULOHA_METOD_OBDOBI MetodObdobi)
        {
            try
            {
                if (MetodObdobi == null)
                    MetodObdobi = ObdobiMetod;

                string cesta = SouboryPomocne.VytvorSoubor(KatalogXlsCesta, "Excel (.xls)|*.xls|All Files (*.*)|*.*");
                if (cesta == null)
                    return;
                else
                    KatalogXlsCesta = cesta;


                MetaData mdou = new MetaData(MetodObdobi);
                mdou.VytvorXlsVystup(KatalogXlsCesta);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi vytven katalogu odvozench ukazatel:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Katalog ou", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }


        /// <summary>
        /// Zmna kolekce tabulek v obdob.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ObdobiOU_TAB_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            try
            {
                //Pidvm ke kad nov tabulce udlost na zmnu kolekce OU
                if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
                {
                    foreach (var item in e.NewItems)
                    {
                        OU_TAB newTab = item as OU_TAB;
                        newTab.OU_ODVOZ_UKAZ.CollectionChanged += TabulkaOU_ODVOZ_UKAZ_CollectionChanged;
                    }
                }

            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Zmna kolekce tabulek", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        /// <summary>
        /// Zmna kolekce OU v jedn z tabulek obsaench ve vybranm obdob
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TabulkaOU_ODVOZ_UKAZ_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            OnPropertyChanged("ObdobiMetod");//Obnovm property obdob, kter obsahuje kolekci vech OU v danm obdob a tm se mi aktualizuj zdroje typu Odvozenho ukazatele
            
        }
        #endregion Obdob

        #region Tabulky
        /// <summary>
        /// Zakld novou tabulku pro dan obdob
        /// </summary>
        /// <param name="Obdobi"></param>
        internal void NovaTab()
        {
            try
            {
                OU_TAB NovaTabulka = new OU_TAB { JMENO = "Nova", GEN_ZALOZ_PK = 1 };
                NovaTabulka.Pridej(ObdobiMetod);

                //Vyberu novou tabulku:
                Tabulka = NovaTabulka;

                OtvritNoveOkno.Invoke(NovaTabulka, null);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi vytven nov tabulky:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Nov tabulka", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }


        #endregion Tabulky

        #region OU
        /// <summary>
        /// Spout SQL kd OU 
        /// </summary>
        /// <param name="OdvozUkaz"></param>
        internal void SpocitatOU(object OdvozUkaz)
        {
            try
            {
                OU_ODVOZ_UKAZ ou = (OU_ODVOZ_UKAZ)OdvozUkaz;

                try
                {
                    //Pokud nen otevn spojen do oracle oteve se
                    if (MyDBContext.OUdotConn.State != ConnectionState.Open)
                        MyDBContext.OUdotConn.Open();

                    //Sputn sql na kontrolu hodnot PK
                    System.Data.Common.DbCommand cmdTAB = MyDBContext.OUdotConn.CreateCommand();

                    //Kotrola existence tabulky
                    //sql kter hled podle jmna tabulku v oracle
                    cmdTAB.CommandText = string.Format(@"SELECT TABLE_NAME FROM ALL_TABLES WHERE TABLE_NAME='{0}'", ou.OU_TAB.JMENO.ToUpper());
                    //Sputn sql commandu pokud nebyla nalezena vrac null
                    object vysledek = cmdTAB.ExecuteScalar();
                    if (vysledek == null)
                        throw new Exception("Tabulka neexistuje. Nejdve spotejte cel obdob nebo tabulku.");

                    cmdTAB.CommandText = string.Format("select count(*) from {0}", ou.OU_TAB.JMENO);

                    var pocetRadku = cmdTAB.ExecuteScalar();

                    if (Int32.Parse(pocetRadku.ToString()) <= 0)
                    {
                        throw new Exception("Tabulka neobsahuje dn primrn kle. Nejdve spotejte cel obdob nebo tabulku.");
                    }

                    Services.SpusteneniOraKodu(ou, MyDBContext.OUdotConn);


                    //System.Data.Common.DbCommand cmd = MyDBContext.OUdotConn.CreateCommand();

                    //cmd.CommandText = ou.SQL_DOTAZ;
                    //cmd.ExecuteNonQuery();
                }
                finally
                {
                    MyDBContext.OUdotConn.Close();
                }
            }
            catch (Exception ex)
            {

                string zprava = string.Format("Chyba vpotu:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Vpoet OU", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        /// <summary>
        /// Mae objekt OU_ODVOZ_UKAZ
        /// </summary>
        /// <param name="OdvozUkaz"></param>
        internal void SmazatOdvozUkaz(object OdvozUkaz)
        {
            try
            {
                MessageBoxResult mbr = MessageBox.Show("Opravdu si pejete smazat odvozen ukazatel?", "Smazat OU", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                if (mbr != MessageBoxResult.Yes)
                    return;

                OU_ODVOZ_UKAZ OUVymaz = OdvozUkaz as OU_ODVOZ_UKAZ;
                if (OUVymaz == null)
                    throw new Exception("Neznm typ.");

                if (OUVymaz.OU_ODVOZ_UKAZ2.Count > 0)//je pouit jako zdroj pro jin OU
                {
                    string zprava = string.Format("Odvozen ukazatel, kter si pejete vymazat slou jako zdroj pro jin OU.{0}Nejdve upravte zdroje tchto OU a pot bude mon vymazat {1}.{0}{0}Pejete si tyto OU zobrazit?", Environment.NewLine, OUVymaz.NAZEV);
                    MessageBoxResult mbr2 = MessageBox.Show(zprava, "Smazat odvozen ukazatel", MessageBoxButton.OKCancel, MessageBoxImage.Error);
                    if (mbr2 == MessageBoxResult.OK)
                    {
                        foreach (var OU in OUVymaz.OU_ODVOZ_UKAZ2)
                        {
                            OtvritNoveOkno.Invoke(OU, null);
                        }
                    }
                    return;
                }

                ZavritOkno.Invoke(OUVymaz, null);
                MyDBContext.Entity.OU_ODVOZ_UKAZ.Remove(OUVymaz);

            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi mazn odvozenho ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Smazat odvozen ukazatel", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
        /// <summary>
        /// Zakld pro danou tabulku nov OU
        /// </summary>
        /// <param name="Tabulka"></param>
        internal void NovyOU()
        {
            try
            {
                if (Tabulka == null)
                    throw new Exception("Nen vybran tabulka.");

                OU_ODVOZ_UKAZ NovyOU = new OU_ODVOZ_UKAZ();


                NovyOU.Pridej(Tabulka);


                OtvritNoveOkno.Invoke(NovyOU, null);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi vytven novho odvozenho ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Nov OU", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }

        /// <summary>
        /// Naklonuje OU podle navolenho potu klon a do zvolen tabulky
        /// </summary>
        /// <param name="OdvozUkaz">Klonovan OU</param>
        internal void KlonovatOU(object OdvozUkaz)
        {
            IsBusy = true;
            try
            {
                //Definice klonovn:
                KlonovatOUWindow kOUw = new KlonovatOUWindow(ObdobiMetod.OU_TAB, Tabulka);
                if (kOUw.ShowDialog() != true)
                {
                    return;
                }

                OU_ODVOZ_UKAZ vzorovyOU = OdvozUkaz as OU_ODVOZ_UKAZ;
                OU_TAB doTabulky = (OU_TAB)kOUw.cbTabulka.SelectedItem;
                if (vzorovyOU == null)
                    throw new ArgumentNullException("Odvozen ukazatel je nulov");

                for (int i = 1; i <= kOUw.iudPocetNovychOU.Value; i++)
                {
                    //Klonuje pouze samotn objekt ne navazane vazby na jin objekty nebo kolekce
                    OU_ODVOZ_UKAZ cloneOU = (OU_ODVOZ_UKAZ)DBContext.Instance.Entity.Entry(vzorovyOU).CurrentValues.ToObject();


                    //1.Vlo do DBContextu:
                    if (doTabulky.OU_PRIMARNI_KLICE.Count == 0)
                    {
                        throw new Exception("Chyb primrn kl tabulky.");
                    }
                    cloneOU.NAZEV = "Nov_" + i;
                    cloneOU.STAV = false;//stav novho OU nastavm flase
                    cloneOU.OPRAVNY_KOD = null;
                    cloneOU.ID_FUNKCE = 1; //Funkci nastavm na Vlstn
                    cloneOU.SQL_DOTAZ = null;
                    cloneOU.OU_TAB = doTabulky;
                    DBContext.Instance.Entity.OU_ODVOZ_UKAZ.Add(cloneOU);

                    //2.Klonovn kategorii a pekdovn:
                    foreach (var vzorovaCat in vzorovyOU.OU_CATEGORY)
                    {
                        OU_CATEGORY cloneCat = (OU_CATEGORY)DBContext.Instance.Entity.Entry(vzorovaCat).CurrentValues.ToObject();
                        cloneCat.OU_ODVOZ_UKAZ = cloneOU;
                        DBContext.Instance.Entity.OU_CATEGORY.Add(cloneCat);

                        foreach (var vzorPrekod in vzorovaCat.OU_PREKODOVANI)
                        {
                            OU_PREKODOVANI clonePrekod = (OU_PREKODOVANI)DBContext.Instance.Entity.Entry(vzorPrekod).CurrentValues.ToObject();
                            clonePrekod.OU_CATEGORY = cloneCat;
                            DBContext.Instance.Entity.OU_PREKODOVANI.Add(clonePrekod);
                        }
                    }

                    //3.Klonovn vech typ zdroj:
                    foreach (var bdbc_sloupec in vzorovyOU.BDBC_SLOUPCE)
                    {
                        cloneOU.BDBC_SLOUPCE.Add(bdbc_sloupec);
                    }
                    foreach (var bdbc_pk in vzorovyOU.BDBC_PRIMARNI_KLICE)
                    {
                        cloneOU.BDBC_PRIMARNI_KLICE.Add(bdbc_pk);
                    }
                    foreach (var zdroj_ou in vzorovyOU.OU_ODVOZ_UKAZ1)
                    {
                        try
                        {
                            cloneOU.OU_ODVOZ_UKAZ1.Add(zdroj_ou);
                        }
                        catch (System.ComponentModel.DataAnnotations.ValidationException vex)
                        {
                            string zprava = string.Format("Chyba pi vkldn zdroje {1}.{0}Klonovan OU bude oznaen jako nehotov.{0}{0}{2}", Environment.NewLine, zdroj_ou.NAZEV, vex.Message);
                            MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                        }

                    }
                    foreach (var cisel in vzorovyOU.CISEL_SEZNAM)
                    {
                        cloneOU.CISEL_SEZNAM.Add(cisel);
                    }



                    OtvritNoveOkno.Invoke(cloneOU, null);
                }




            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba pi klonovn odvozenho ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            finally { IsBusy = false; }

        }

        /// <summary>
        /// Pouze pro programtora! Slou k naklonovn vce OU do jin tabulky
        /// </summary>
        private void KlonovatDoJineTabOU()
        {
            var spolecne = ObdobiMetod.OU_TAB.Where(t => t.JMENO == "ZP151_OU_OCR").FirstOrDefault().OU_ODVOZ_UKAZ.Where(o => !string.IsNullOrEmpty(o.NAZEV_EU) && o.NAZEV_EU.Contains("R") && o.SPOJ == "spolen").ToList();

            KlonovatOUWindow kOUw = new KlonovatOUWindow(ObdobiMetod.OU_TAB, Tabulka);
            if (kOUw.ShowDialog() != true)
            {
                return;
            }

            OU_TAB doTabulky = (OU_TAB)kOUw.cbTabulka.SelectedItem;
            //1.Vlo do DBContextu:
            if (doTabulky.OU_PRIMARNI_KLICE.Count == 0)
            {
                throw new Exception("Chyb primrn kl tabulky.");
            }

            foreach (var OdvozUkaz in spolecne)
            {


                IsBusy = true;
                try
                {
                    //Definice klonovn:


                    OU_ODVOZ_UKAZ vzorovyOU = OdvozUkaz as OU_ODVOZ_UKAZ;
                    if (vzorovyOU == null)
                        throw new ArgumentNullException("Odvozen ukazatel je nulov");

                    for (int i = 1; i <= kOUw.iudPocetNovychOU.Value; i++)
                    {
                        //Klonuje pouze samotn objekt ne navazane vazby na jin objekty nebo kolekce
                        OU_ODVOZ_UKAZ cloneOU = (OU_ODVOZ_UKAZ)DBContext.Instance.Entity.Entry(vzorovyOU).CurrentValues.ToObject();



                        //cloneOU.NAZEV = "Nov_" + i;


                        //2.Klonovn kategorii a pekdovn:
                        foreach (var vzorovaCat in vzorovyOU.OU_CATEGORY)
                        {
                            OU_CATEGORY cloneCat = (OU_CATEGORY)DBContext.Instance.Entity.Entry(vzorovaCat).CurrentValues.ToObject();
                            cloneCat.OU_ODVOZ_UKAZ = cloneOU;
                            DBContext.Instance.Entity.OU_CATEGORY.Add(cloneCat);

                            //PEKDOVN NEKLONUJI PROTOE SE NASTAV PROST PEVZET Z PVODNHO OU
                            //foreach (var vzorPrekod in vzorovaCat.OU_PREKODOVANI)
                            //{
                            //    OU_PREKODOVANI clonePrekod = (OU_PREKODOVANI)DBContext.Instance.Entity.Entry(vzorPrekod).CurrentValues.ToObject();
                            //    clonePrekod.OU_CATEGORY = cloneCat;
                            //    DBContext.Instance.Entity.OU_PREKODOVANI.Add(clonePrekod);
                            //}
                        }

                        //3.Klonovn vech typ zdroj:
                        //foreach (var bdbc_sloupec in vzorovyOU.BDBC_SLOUPCE)
                        //{
                        //    cloneOU.BDBC_SLOUPCE.Add(bdbc_sloupec);
                        //}
                        //foreach (var bdbc_pk in vzorovyOU.BDBC_PRIMARNI_KLICE)
                        //{
                        //    cloneOU.BDBC_PRIMARNI_KLICE.Add(bdbc_pk);
                        //}
                        //foreach (var zdroj_ou in vzorovyOU.OU_ODVOZ_UKAZ1)
                        //{
                        //    try
                        //    {
                        //        cloneOU.OU_ODVOZ_UKAZ1.Add(zdroj_ou);
                        //    }
                        //    catch (System.ComponentModel.DataAnnotations.ValidationException vex)
                        //    {
                        //        string zprava = string.Format("Chyba pi vkldn zdroje {1}.{0}Klonovan OU bude oznaen jako nehotov.{0}{0}{2}", Environment.NewLine, zdroj_ou.NAZEV, vex.Message);
                        //        MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                        //    }

                        //}
                        //foreach (var cisel in vzorovyOU.CISEL_SEZNAM)
                        //{
                        //    cloneOU.CISEL_SEZNAM.Add(cisel);
                        //}

                        //PI KLONOVN NASTAVIT JAKO ZDROJ PVODN OU:
                        try
                        {
                            cloneOU.OU_ODVOZ_UKAZ1.Add(vzorovyOU);
                        }
                        catch (System.ComponentModel.DataAnnotations.ValidationException vex)
                        {
                            string zprava = string.Format("Chyba pi vkldn zdroje {1}.{0}Klonovan OU bude oznaen jako nehotov.{0}{0}{2}", Environment.NewLine, vzorovyOU.NAZEV, vex.Message);
                            MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                            cloneOU.STAV = false;//stav novho OU nastavm flase
                        }

                        cloneOU.OU_TAB = doTabulky;


                        //if (vzorovyOU.ID_FUNKCE == 1)
                        //{
                        //    if (vzorovyOU.SQL_DOTAZ != null)
                        //    {
                        //        cloneOU.SQL_DOTAZ = Regex.Replace(vzorovyOU.SQL_DOTAZ, "MERGE INTO " + vzorovyOU.OU_TAB.JMENO, "MERGE INTO " + doTabulky.JMENO, RegexOptions.IgnoreCase);
                        //        cloneOU.SQL_DOTAZ = Regex.Replace(vzorovyOU.SQL_DOTAZ, "UPDATE " + vzorovyOU.OU_TAB.JMENO, "UPDATE " + doTabulky.JMENO, RegexOptions.IgnoreCase);
                        //    }

                        //}
                        //else
                        //{
                        //    try
                        //    {
                        //        cloneOU.SQL_DOTAZ = cloneOU.ZmenaFunkce(vzorovyOU.OU_FUNKCE);
                        //    }
                        //    catch (Exception ex)
                        //    {
                        //        string zprava = string.Format("Chyba pi generovn SQL pro {1}:{0}{2}", Environment.NewLine, cloneOU.NAZEV, ex.Message);
                        //        MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                        //        cloneOU.ID_FUNKCE = 1;
                        //        cloneOU.STAV = false;//stav novho OU nastavm flase
                        //    }

                        //}

                        //PI KLONOVN NASTAVENO VDY PROST PEVZET ZE ZDROJOVHO:
                        try
                        {
                            cloneOU.OU_FUNKCE = DBContext.Instance.Entity.OU_FUNKCE.Where(f => f.ID == 2).FirstOrDefault();//Vyberu prost pevzet
                            cloneOU.SQL_DOTAZ = cloneOU.ZmenaFunkce(cloneOU.OU_FUNKCE);
                        }
                        catch (Exception ex)
                        {
                            string zprava = string.Format("Chyba pi generovn SQL pro {1}:{0}{2}", Environment.NewLine, cloneOU.NAZEV, ex.Message);
                            MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                            cloneOU.ID_FUNKCE = 1;
                            cloneOU.STAV = false;//stav novho OU nastavm flase
                        }


                        DBContext.Instance.Entity.OU_ODVOZ_UKAZ.Add(cloneOU);

                    }




                }
                catch (Exception ex)
                {
                    string zprava = string.Format("Chyba pi klonovn odvozenho ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                    MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                }
                finally { IsBusy = false; }
            }
        }

        /// <summary>
        /// Pouze pro programtora! Slou k hromadnmu pesunu OU do jin tabulky
        /// </summary>
        private void PresunOU()
        {
            //var spolecne = ObdobiMetod.OU_TAB.Where(t => t.JMENO == "ZP151_OU_OCR").FirstOrDefault().OU_ODVOZ_UKAZ.Where(o => !string.IsNullOrEmpty(o.NAZEV_EU) && o.NAZEV_EU.Contains("R") && o.SPOJ == "evropsk").ToList();

            string[] presun = new string[] { "MCROK", "CZ", "EU_OSOBA", "EU_IMIGROK", "EU_IDHD", "BKOEF", "LKOEF2", "LKOEF3", "LKOEF4", "EU_PANEL_OS", "EU_DRUH_PRIT", "MES_PRIST", "EU_L_EA", "EU_B_PA", "EU_IC_OTCE", "EU_IC_MATKY", "EU_IC_PARTN", "OS_STATUS", "DATA_STATUS", "ROZHOVOR", "OC_PROXY", "EU_PREDSK", "EU_ZSKOLA", "EU_DRUZ", "EU_ZARIZ", "EU_CHUVA", "EU_PRIBUZ", "DKOEF" };
            var spolecne = ObdobiMetod.OU_TAB.Where(t => t.JMENO == "ZP151_OU_JCR").FirstOrDefault().OU_ODVOZ_UKAZ.Where(o => o.NAZEV == "MES_PRIT").ToList();

            KlonovatOUWindow kOUw = new KlonovatOUWindow(ObdobiMetod.OU_TAB, Tabulka);
            if (kOUw.ShowDialog() != true)
            {
                return;
            }

            OU_TAB doTabulky = (OU_TAB)kOUw.cbTabulka.SelectedItem;
            //1.Vlo do DBContextu:
            if (doTabulky.OU_PRIMARNI_KLICE.Count == 0)
            {
                throw new Exception("Chyb primrn kl tabulky.");
            }

            foreach (var OdvozUkaz in spolecne)
            {


                IsBusy = true;
                try
                {
                    //Definice klonovn:


                    OU_ODVOZ_UKAZ vzorovyOU = OdvozUkaz as OU_ODVOZ_UKAZ;
                    if (vzorovyOU == null)
                        throw new ArgumentNullException("Odvozen ukazatel je nulov");

                    for (int i = 1; i <= kOUw.iudPocetNovychOU.Value; i++)
                    {




                        //cloneOU.NAZEV = "Nov_" + i;


                        string puvdJmTab = vzorovyOU.OU_TAB.JMENO;
                        vzorovyOU.OU_TAB = doTabulky;


                        if (vzorovyOU.ID_FUNKCE == 1)
                        {
                            if (vzorovyOU.SQL_DOTAZ != null)
                            {
                                vzorovyOU.SQL_DOTAZ = Regex.Replace(vzorovyOU.SQL_DOTAZ, "MERGE INTO " + puvdJmTab, "MERGE INTO " + doTabulky.JMENO, RegexOptions.IgnoreCase);
                                vzorovyOU.SQL_DOTAZ = Regex.Replace(vzorovyOU.SQL_DOTAZ, "UPDATE " + puvdJmTab, "UPDATE " + doTabulky.JMENO, RegexOptions.IgnoreCase);
                            }

                        }
                        else
                        {
                            try
                            {
                                vzorovyOU.SQL_DOTAZ = vzorovyOU.ZmenaFunkce(vzorovyOU.OU_FUNKCE);
                            }
                            catch (Exception ex)
                            {
                                string zprava = string.Format("Chyba pi generovn SQL pro {1}:{0}{2}", Environment.NewLine, vzorovyOU.NAZEV, ex.Message);
                                MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                                vzorovyOU.ID_FUNKCE = 1;
                                vzorovyOU.STAV = false;//stav novho OU nastavm flase
                            }

                        }



                    }




                }
                catch (Exception ex)
                {
                    string zprava = string.Format("Chyba pi klonovn odvozenho ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                    MessageBox.Show(zprava, "Klonovn OU", MessageBoxButton.OK, MessageBoxImage.Error);
                }
                finally { IsBusy = false; }
            }

            //KD NA NASTAVEN POROSTHO PREVZET PODLE NZVU OU Z JIN TABULKY
            //string ouSpol = "";
            //var zdroje = Tabulka.ULOHA_METOD_OBDOBI.OU_TAB.Where(t => t.JMENO == "ZP151_OU_OCR").First().OU_ODVOZ_UKAZ;

            //var spol = Tabulka.OU_ODVOZ_UKAZ.Where(o => o.SPOJ == "spolen");
            //foreach (var ou in spol)
            //{
            //    ou.BDBC_PRIMARNI_KLICE.Remove(p=> p.ID != null);
            //    ou.BDBC_SLOUPCE.Remove(p => p.ID != null);
            //    ou.OU_ODVOZ_UKAZ1.Remove(p => p.ID != null);
            //    ou.EXT_SLOUPCE.Remove(p => p.ID != null);


            //    foreach (var cat in ou.OU_CATEGORY)
            //    {
            //        DBContext.Instance.Entity.OU_PREKODOVANI.RemoveRange(cat.OU_PREKODOVANI);

            //    }


            //    OU_ODVOZ_UKAZ zdroj = zdroje.Where(z => z.NAZEV == ou.NAZEV).First();
            //    ou.OU_ODVOZ_UKAZ1.Add(zdroj);

            //    ou.OU_FUNKCE = DBContext.Instance.Entity.OU_FUNKCE.Where(f => f.ID == 2).FirstOrDefault();//Vyberu prost pevzet
            //    ou.SQL_DOTAZ = ou.ZmenaFunkce(ou.OU_FUNKCE);

            //    ouSpol = string.Format("{0}{2}{1}", ouSpol, Environment.NewLine, ou.NAZEV);
            //}

        }

        /// <summary>
        /// Sead OU ve vybran tabulce, podle kd tmat definovanch u jednotlivch OU
        /// http://stackoverflow.com/questions/24147585/collectionviewsource-with-custom-sort
        /// </summary>
        internal void SortOUTema(System.Windows.Controls.DataGrid dg)
        {
            if (Tabulka != null)
            {
                ICollectionView view = System.Windows.Data.CollectionViewSource.GetDefaultView(Tabulka.OU_ODVOZ_UKAZ);
                System.Windows.Data.ListCollectionView lv = view as System.Windows.Data.ListCollectionView;
                lv.SortDescriptions.Clear();
                //Nutnost vymazat vechna dvj oznaen sortingu pmo na datagridu 
                if (dg != null)
                {
                    foreach (var column in dg.Columns)
                    {
                        column.SortDirection = null;
                    }
                }
                lv.CustomSort = new SortOUpodleTema();
                lv.Refresh();
            }
        }

        #endregion OU

        #region Uloit
        /// <summary>
        /// Ukld DB context asynchron
        /// </summary>
        internal async void UlozitAsync()
        {
            if (Validace.ValidacniChyby.Count > 0)
            {
                //Zobrazim chyby:
                OtvritNoveOkno.Invoke(Validace.ValidacniChyby, null);
                MessageBox.Show("Byly zjitny chyby pi validaci. Nelze uloit zmny.", "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);
                return;
            }

            try
            {
                IsBusy = true;


                await MyDBContext.Entity.SaveChangesAsync();

                IsBusy = false;

            }
            catch (DbEntityValidationException ex)
            {
                ZobrazValidacniChyby(ex);

            }
            catch (DbUpdateConcurrencyException ex)
            {
                ZobrazConcurrencyException(ex);

            }
            catch (System.Data.Entity.Infrastructure.DbUpdateException ex)
            {
                string chyba = ex.Message.ToString();
                if (ex.InnerException != null)
                {
                    chyba = ex.InnerException.Message;
                    if (ex.InnerException.InnerException != null)
                    {
                        chyba = ex.InnerException.InnerException.Message;
                    }
                }

                MessageBox.Show("Nelze uloit zmny. Chyba:" + Environment.NewLine + chyba, "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);

                var ObjektySChybou = ex.Entries.ToList();
                foreach (var objCh in ObjektySChybou)
                {
                    if (objCh.State != EntityState.Added)
                    {
                        objCh.Reload();
                    }
                    else
                    {
                        Application.Current.Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(
                  delegate() { objCh.State = EntityState.Detached; }));

                    }

                }

            }
            catch (Exception ex)//(DbEntityValidationException ex)
            {
                string chyba = ex.Message.ToString();
                if (ex.InnerException != null)
                {
                    chyba = ex.InnerException.Message;
                    if (ex.InnerException.InnerException != null)
                    {
                        chyba = ex.InnerException.InnerException.Message;
                    }
                }

                MessageBox.Show("Nelze uloit zmny. Chyba:" + Environment.NewLine + chyba, "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);

            }
            finally
            {
                IsBusy = false;
            }
        }

        /// <summary>
        /// Ukld DB context
        /// </summary>
        internal bool Ulozit()
        {
            bool result = false;
            if (Validace.ValidacniChyby.Count > 0)
            {
                //Zobrazim chyby:
                OtvritNoveOkno.Invoke(Validace.ValidacniChyby, null);
                MessageBox.Show("Byly zjitny chyby pi validaci. Nelze uloit zmny.", "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);
                return result;
            }

            try
            {
                MyDBContext.Entity.SaveChanges();
                result = true;
            }
            catch (DbEntityValidationException ex)
            {
                ZobrazValidacniChyby(ex);
            }
            catch (DbUpdateConcurrencyException ex)
            {
                ZobrazConcurrencyException(ex);
            }
            catch (System.Data.Entity.Infrastructure.DbUpdateException ex)
            {
                string chyba = ex.Message.ToString();
                if (ex.InnerException != null)
                {
                    chyba = ex.InnerException.Message;
                    if (ex.InnerException.InnerException != null)
                    {
                        chyba = ex.InnerException.InnerException.Message;
                    }
                }

                MessageBox.Show("Nelze uloit zmny. Chyba:" + Environment.NewLine + chyba, "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);

                var ObjektySChybou = ex.Entries.ToList();
                foreach (var objCh in ObjektySChybou)
                {
                    if (objCh.State != EntityState.Added)
                    {
                        objCh.Reload();
                    }
                    else
                    {
                        Application.Current.Dispatcher.BeginInvoke(DispatcherPriority.Normal, new Action(
                  delegate() { objCh.State = EntityState.Detached; }));

                    }

                }

            }
            catch (Exception ex)//(DbEntityValidationException ex)
            {
                string chyba = ex.Message.ToString();
                if (ex.InnerException != null)
                {
                    chyba = ex.InnerException.Message;
                    if (ex.InnerException.InnerException != null)
                    {
                        chyba = ex.InnerException.InnerException.Message;
                    }
                }

                MessageBox.Show("Nelze uloit zmny. Chyba:" + Environment.NewLine + chyba, "Uloit", MessageBoxButton.OK, MessageBoxImage.Error);

            }
            return result;

        }

        /// <summary>
        /// Zobrazuje chyby pi ukldn, kter neproli validac
        /// </summary>
        /// <param name="ex">Vechny vyjmky pi uloen.</param>
        internal void ZobrazValidacniChyby(DbEntityValidationException ex)
        {
            foreach (DbEntityValidationResult item in ex.EntityValidationErrors)
            {
                // Get entry

                DbEntityEntry entry = item.Entry;
                //string entityTypeName = entry.Entity.GetType().Name;

                // Display or log error messages
                foreach (DbValidationError subItem in item.ValidationErrors)
                {
                    string message = string.Format("Chyba: {1}{0}{1}{1}Data nebyla uloena.",
                             subItem.ErrorMessage, Environment.NewLine, subItem.PropertyName);
                    MessageBox.Show(message, "Chyba pi ukldn do DB", MessageBoxButton.OK, MessageBoxImage.Error);
                }

                //Vratit zmny na neuloench objektech
                //switch (entry.State)
                //{
                //    case EntityState.Added:
                //        entry.State = EntityState.Detached;
                //        break;
                //    case EntityState.Modified:
                //        entry.CurrentValues.SetValues(entry.OriginalValues);
                //        entry.State = EntityState.Unchanged;
                //        break;
                //    case EntityState.Deleted:
                //        entry.State = EntityState.Unchanged;
                //        break;
                //}


            }
        }

        /// <summary>
        /// Zobrazen konfliktnich vyjmek uivateli pi ukldn dat a obnoven tchto dat z db 
        /// </summary>
        /// <param name="ex">Chyba pi uloen do db</param>
        internal void ZobrazConcurrencyException(DbUpdateConcurrencyException ex)
        {
            //Projede vechny objekty, kter pi uloen vyvolali vyjmku
            var chyby = ex.Entries.ToList();
            foreach (var chyba in chyby)
            {
                //sestaven chybov hlky, kde jsou vidt vechny hodnoty chybnho objektu
                string zprava = string.Format("Chyba pi ukldn objektu:{0}", Environment.NewLine);
                if (chyba.State != EntityState.Deleted)
                {
                    //uloen nzvu proprt objektu
                    var jmenaProprt = chyba.CurrentValues.PropertyNames;
                    foreach (var proprty in jmenaProprt)
                    {
                        string hodnota = "";
                        if (chyba.Member(proprty).CurrentValue != null)
                            hodnota = chyba.Member(proprty).CurrentValue.ToString();
                        zprava = String.Format("{0}{2} = {3}{1}", zprava, Environment.NewLine, proprty, hodnota);
                    }
                    zprava = string.Format("{0}{1}Objekt se nepodailo uloit do databze, protoe dole k jeho zmn jinm uivatlem. Budou natena nov data z databze.", zprava, Environment.NewLine);
                }
                else { zprava = string.Format("Objekt, kter se snate smazat, ji byl odstrann, nebo zmnn jinm uivatelem.{0}{0}Objekt bude optovn nate z databze.", Environment.NewLine); }

                MessageBox.Show(zprava, "Save error", MessageBoxButton.OK, MessageBoxImage.Error);
                //naten objektu z db
                chyba.Reload();
            }
            //Zmna vybran tabulky v UI, aby se uivateli projevyli zmny nov natench objekt
            //int puvoSI = CBTabulkaSelectedIndex;
            //VybranaTabulka = null;
            //CBTabulkaSelectedIndex = puvoSI;

        }

        #endregion Uloit

        #region Extern Zdrjoe
        
        /// <summary>
        /// Spust prvodce iportem externho ydroje
        /// </summary>
        internal void ImportExt()
        {

            if (!Ulozit())//Probhne uloen s chybou nelze pokraovat
            {
                return;
            }
            OuDot.ViewModel.IporterWizzard.ImporterWindow iw = new IporterWizzard.ImporterWindow();
            iw.ShowDialog();

            //Po naimportovn zdroje obnovm kolkeci externch zdroj
            ExterniZdroje = new ObservableCollection<EXT_SLOUPCE>(DBContext.Instance.Entity.EXT_SLOUPCE);
            NastaveniFiltruExtZdroje();
        }
        /// <summary>
        /// Nastav filtr na kolekci Externch zdroj, na platnost do odpovdajc datu eten v ternu
        /// </summary>
        internal void NastaveniFiltruExtZdroje()
        {

            //Zskm instanci filtru, kter m zajm
            PlatnostDoFilterInitializer i = new RozsireniGrafika.PlatnostDoFilterInitializer();
            // Zskm FilterPresenter, kter je pipojen na moj filtrovanou kolekci
            BolapanControl.ItemsFilter.FilterPresenter productsCollectionViewFilterPresenter = BolapanControl.ItemsFilter.FilterPresenter.TryGet(ExterniZdroje);
            //Podle filtrovan property a zskanho filtru dostanu konkrtn filtr kolekce
            var filter = productsCollectionViewFilterPresenter.TryGetFilter("EXT_TABULKY.PLATNOST_DO", i) as PlatnostDoRangeFilter;

            filter.CompareFrom = ObdobiTeren.SETRENI_TEREN_DO;
        }
       
        #endregion Extern Zdrjoe

        #endregion Prce s db contextem

        #region Npovda

        /// <summary>
        /// Zobraz soubor s npovdou
        /// </summary>
        internal void Napoveda()
        {
            //kontrola existence
            string cestaHelpPdf = Path.Combine(AppDomain.CurrentDomain.BaseDirectory, @"help", "oudot.pdf");
            if (!File.Exists(cestaHelpPdf))
            {
                MessageBox.Show("Chyba - Nebyl nalezen soubor s npovdou.", "Npovda", MessageBoxButton.OK, MessageBoxImage.Error);
                return;
            }
            //sputn
            try { Process.Start(cestaHelpPdf); }
            catch
            {
                string zprava = string.Format("Chyba - Nelze spustit soubor s npovdou.{0}{1}", Environment.NewLine, cestaHelpPdf);
                MessageBox.Show(zprava, "Npovda", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }

        public void OProgramuButton()
        {
            try
            {
                OProgramuWindow opw = new OProgramuWindow();
                opw.ShowDialog();
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "O programu", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        #endregion Npovda

        #region Aktualizace
        void bgwKontrolaVerzi_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (e.Error == null && !String.IsNullOrEmpty((string)e.Result))
                this.Aktualizace((string)e.Result);
        }
        /// <summary>
        ///  Sputn aktualizace programu po vyhledn novj verze
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void bgwKontrolaVerzi_DoWork(object sender, DoWorkEventArgs e)
        {
            //Hledn novj verze
            e.Result = this.NovaVerze(false);
        }
        /// <summary>
        /// Aktualizace programu
        /// </summary>
        /// <param name="InstalSoubor">Instalan soubor</param>
        private void Aktualizace(string InstalSoubor)
        {
            //1) Dotaz zda instalovat novou verzi
            if (!String.IsNullOrEmpty(InstalSoubor))
            {
                if (MessageBox.Show("Byla nalezena nov verze programu. Chcete ji nainstalovat?", "Aktualizace programu", MessageBoxButton.YesNo, MessageBoxImage.Question) != MessageBoxResult.Yes)
                {
                    return;
                }
            }
            else
                return;

            //2) Ukonit program a spustit instalaci
            try
            {
                String InstalNewPath = Path.Combine(@"d:\OuDot", Path.GetFileName(InstalSoubor));
                File.Copy(InstalSoubor, InstalNewPath, true);
                Process Aktualizace = new Process();
                Aktualizace.StartInfo.FileName = InstalNewPath;
                Aktualizace.StartInfo.Arguments = "/zpozdeni=A";
                Aktualizace.Start();
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba aktualizace:{0}{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Aktualizace", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            Application.Current.Shutdown();
        }
        /// <summary>
        /// Vrt cestu k instalanmu souboru, pokud byla nalezena novj verze
        /// </summary>
        /// <param name="Msg">Zobrazovat chybov zprvy</param>
        /// <returns></returns>
        private string NovaVerze(bool Msg)
        {
            String AdrUlozisteSprTaz = @"\\10.1.2.16\data\DATA\ZPRAC\CAPI\OuDot";
            //1) Zjistit dostupnost loit
            this.NetUseUloziste();
            if (!Directory.Exists(AdrUlozisteSprTaz))
            {
                if (Msg == true)
                    MessageBox.Show("Nelze se pipojit na loit.", "Aktualizace programu", MessageBoxButton.OK, MessageBoxImage.Stop);

                return "";
            }


            //2) Zskat slo verze ze souboru v loiti
            String[] InstalSoubory = Directory.GetFiles(AdrUlozisteSprTaz, "OuDot_Setup.exe");
            if (InstalSoubory.Length == 0)
                return "";
            FileVersionInfo myFileVersionInfo = FileVersionInfo.GetVersionInfo(InstalSoubory.FirstOrDefault());

            System.Version MyVersion = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;//My.Application.Info.Version;
            //3) Porovnat verze, a pokud je na loiti novj pak nabdnout instalaci
            if ((myFileVersionInfo.FileBuildPart > MyVersion.Build) || (myFileVersionInfo.FileBuildPart == MyVersion.Build && myFileVersionInfo.ProductPrivatePart > MyVersion.MinorRevision))
                return InstalSoubory.FirstOrDefault();


            return "";
        }
        /// <summary>
        /// Pipojen loit
        /// </summary>
        internal void NetUseUloziste()
        {
            Process myprocess = new Process();
            ProcessStartInfo StartInfo = new System.Diagnostics.ProcessStartInfo();

            //Starts the CMD Prompt
            StartInfo.FileName = "cmd.exe";
            StartInfo.RedirectStandardInput = true;
            StartInfo.RedirectStandardOutput = true;
            //Required to redirect
            StartInfo.UseShellExecute = false;
            //Disables the creation of a CMD Prompt outside application.
            StartInfo.CreateNoWindow = true;

            myprocess.StartInfo = StartInfo;
            myprocess.Start();
            System.IO.StreamReader SR = myprocess.StandardOutput;
            System.IO.StreamWriter SW = myprocess.StandardInput;
            //Runs the command you entered...
            SW.WriteLine("NET USE \\10.1.2.16");
            //Exits CMD Prompt
            SW.WriteLine("exit");
            //Displayes the results...
            //Dim Results = SR.ReadToEnd
            SW.Close();
            SR.Close();
        }
        #endregion Aktualizace

        /// <summary>
        /// Zmna dostupnosti pipojen k sti
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void NetworkChange_NetworkAvailabilityChanged(object sender, System.Net.NetworkInformation.NetworkAvailabilityEventArgs e)
        {
            try
            {
                //Pokud se zmn na dostupn povol pravy, pokud dostupn nen zake veker pravy OU
                if (e.IsAvailable == true)
                {
                    IsBusy = false;
                    IsConnectionLost = false;
                }
                else
                {
                    IsBusy = true;
                    IsConnectionLost = true;
                }
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "NetworkAvailabilityChanged", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}