﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data.Entity.Core.Objects;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using GalaSoft.MvvmLight.CommandWpf;
using OuDot.Model;
using OuDot.Properties;
using OuDot.ServicesOudot;
using OuDot.ViewModel.IporterWizzard;

namespace OuDot.ViewModel
{
    public class OdvozUkazDetailsViewModel : ViewModelBase
    {

        private OU_ODVOZ_UKAZ _odvozUkaz;
        /// <summary>
        /// Vybraný odvozený ukazatel
        /// </summary>
        public OU_ODVOZ_UKAZ OdvozUkaz
        {
            get { return _odvozUkaz; }
            set
            {
                if (_odvozUkaz != value)
                {
                    _odvozUkaz = value;
                    OnPropertyChanged();
                }
            }
        }




        private ObservableCollection<OU_TEMATA> _ouTemata;

        public ObservableCollection<OU_TEMATA> OUTemata
        {
            get { return _ouTemata; }
            set
            {
                if (_ouTemata != value)
                {
                    _ouTemata = value;
                    OnPropertyChanged();
                }
            }
        }



        //private string _filterTema;

        //public string FilterTema
        //{
        //    get { return _filterTema; }
        //    set
        //    {
        //        if (_filterTema != value)
        //        {
        //            _filterTema = value;

        //            if (string.IsNullOrEmpty(FilterTema))
        //            {
        //                OdvozUkaz.OU_TEMATA = null;
        //            }
        //            else
        //            {
        //                OdvozUkaz.OU_TEMATA = OUTemata.Where(t => t.POPISEK.ToLower().Contains(FilterTema.ToLower())).FirstOrDefault();
        //            }

        //            OnPropertyChanged();
        //            OnPropertyChanged("TemaText");
        //        }
        //    }
        //}

        //private string _filterTemaKod;

        //public string FilterTemaKod
        //{
        //    get { return _filterTemaKod; }
        //    set
        //    {
        //        if (_filterTemaKod != value)
        //        {
        //            _filterTemaKod = value;

        //            if (string.IsNullOrEmpty(_filterTemaKod))
        //            {
        //                OdvozUkaz.OU_TEMATA = null;
        //            }
        //            else
        //            {
        //                OdvozUkaz.OU_TEMATA = OUTemata.Where(t => t.KOD.ToLower().StartsWith(_filterTemaKod.ToLower())).FirstOrDefault();
        //            }

        //            OnPropertyChanged();
        //            OnPropertyChanged("TemaText");
        //        }
        //    }
        //}

        //public string TemaText
        //{
        //    get
        //    {

        //        string temaString = "";
        //        if (OdvozUkaz.OU_TEMATA != null)
        //        {
        //            //Vyhledání nadřazené kategorie:
        //            string kodNad = OdvozUkaz.OU_TEMATA.KOD.Split('.').FirstOrDefault();
        //            var hlTema = OUTemata.Where(t => t.KOD == kodNad).FirstOrDefault();

        //            temaString = string.Format("{0} - {1} {2}", hlTema.POPISEK, OdvozUkaz.OU_TEMATA.KOD, OdvozUkaz.OU_TEMATA.POPISEK);
        //        }

        //        return temaString;
        //    }

        //}


        //private ObservableCollection<ULOHA> _ulohyTeren;

        //public ObservableCollection<ULOHA> UlohyTeren
        //{
        //    get { return _ulohyTeren; }
        //    set
        //    {
        //        if (_ulohyTeren != value)
        //        {
        //            _ulohyTeren = value;
        //            OnPropertyChanged();
        //        }
        //    }
        //}


        //private ULOHA _ulohaTeren;

        //public ULOHA UlohaTeren
        //{
        //    get { return _ulohaTeren; }
        //    set
        //    {
        //        if (_ulohaTeren != value)
        //        {
        //            _ulohaTeren = value;
        //            OnPropertyChanged();
        //        }
        //    }
        //}


        private BDBCTABULKY _tabTeren;

        public BDBCTABULKY TabTeren
        {
            get { return _tabTeren; }
            set
            {
                if (_tabTeren != value)
                {
                    _tabTeren = value;
                    OnPropertyChanged();
                }
            }
        }

        //NENÍ POTŘEBA, SMAZAT??
        //private ULOHA_OBDOBI _obdobiTeren;

        //public ULOHA_OBDOBI ObdobiTeren
        //{
        //    get { return _obdobiTeren; }
        //    set
        //    {
        //        if (_obdobiTeren != value)
        //        {
        //            _obdobiTeren = value;
        //            OnPropertyChanged();

        //            ZmenaKolekceZdrojuBdbc(value);
        //        }
        //    }
        //}


        private ObservableCollection<OU_FUNKCE> _funkceKolekce;

        public ObservableCollection<OU_FUNKCE> FunkceKolekce
        {
            get { return _funkceKolekce; }
            set
            {
                if (_funkceKolekce != value)
                {
                    _funkceKolekce = value;
                    OnPropertyChanged();
                }
            }
        }



        private bool _funkceHandel;

        public OU_FUNKCE Funkce
        {
            get { return OdvozUkaz.OU_FUNKCE; }
            set
            {
                if (OdvozUkaz.OU_FUNKCE != value)
                {
                    //uložím původní objekt a změní funkci
                    var oldItem = OdvozUkaz.OU_FUNKCE;
                    var oldParam = new List<OU_PARAM_FCE>(OdvozUkaz.OU_PARAM_FCE);//uložím původní parametry funkce
                    OdvozUkaz.OU_FUNKCE = value;
                    OnPropertyChanged();

                    //Smažu veškeré původní parametry pokud není funkce vracena na původní
                    if (!_funkceHandel)
                    {
                        DBContext.Instance.Entity.OU_PARAM_FCE.RemoveRange(OdvozUkaz.OU_PARAM_FCE);
                    }
                    
                    //pokud nebyla vracená na původní hodnotu (_funkceHandel) a nová hodnota není funkce Vlastní
                    if (!_funkceHandel && (value.ID != 1))//Pokud měním na Vlastní (ID 1) neměním sql kód
                    {
                        //Pokud je původní funkce vlastní a má vyplnění nějaký sql dotaz, zobrazím varování o případné ztrátě vlastního textu a případně změnu zruším:
                        if (oldItem.ID == 1 && !string.IsNullOrEmpty(OdvozUkaz.SQL_DOTAZ))
                        {
                            string zprava = string.Format("Opravdu si přejete změnit funkci?{0}Dojde ke ztrátě vlastního napsaného sql dotazu.", Environment.NewLine);
                            MessageBoxResult mbr = MessageBox.Show(zprava, "Změna funkce", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                            if (mbr != MessageBoxResult.Yes)
                            {
                                System.Windows.Threading.Dispatcher.CurrentDispatcher.BeginInvoke(new Action(() =>
                                {
                                    _funkceHandel = true;
                                    Funkce = oldItem;
                                }), System.Windows.Threading.DispatcherPriority.ApplicationIdle);
                                return;
                            }
                        }

                        //přegenerování sql:
                        try
                        {
                            
                            OdvozUkaz.SQL_DOTAZ = OdvozUkaz.ZmenaFunkce(value);
                            OnPropertyChanged("OdvozUkaz");
                        }
                        catch (Exception ex)
                        {
                            string zprava = string.Format("Chyba při změně funkce odvozeného ukazatele:{0}{1}", Environment.NewLine, ex.Message);
                            MessageBox.Show(zprava, "Změna funkce", MessageBoxButton.OK, MessageBoxImage.Error);

                            //Nastal chyba při generování sql vracím na původní objekt
                            //Musím vrátit po skonční akce
                            System.Windows.Threading.Dispatcher.CurrentDispatcher.BeginInvoke(new Action(() =>
                                {
                                    _funkceHandel = true;
                                    Funkce = oldItem;
                                }), System.Windows.Threading.DispatcherPriority.ApplicationIdle);

                            //Vrátím parametry na původní hodnoty:
                            DBContext.Instance.Entity.OU_PARAM_FCE.RemoveRange(OdvozUkaz.OU_PARAM_FCE);
                            foreach (var parama in oldParam)//U parametru je nutné obnovit vazbu na OU, která byla ztracena při odebraní parametrů z contextu, proto je nutné použít funkci Attach
                            {
                                DBContext.Instance.Entity.OU_PARAM_FCE.Attach(parama);
                            }
                            
                        }

                    }
                    _funkceHandel = false;
                    OnPropertyChanged("PovolitZmenu");
                }
            }
        }



        //public bool StavOU
        //{
        //    get { return OdvozUkaz.STAV; }
        //    set
        //    {
        //        if (OdvozUkaz.STAV != value)
        //        {
        //            OdvozUkaz.STAV = value;
        //            OnPropertyChanged();
        //            OnPropertyChanged("PovolitZmenu");

        //        }
        //    }
        //}


        /// <summary>
        /// Vrací podle vybrané funkce zda jsou umožněny změny některých parametrů OU
        /// </summary>
        public bool PovolitZmenu
        {
            get
            {
                if (Funkce.ID == 1 && OdvozUkaz.STAV == false)//Pokud je funkce Vlastní umožním úpravy
                    return true;
                else
                    return false;
            }
        }


        private ObservableCollection<OU_TYP> _typy;

        public ObservableCollection<OU_TYP> Typy
        {
            get { return _typy; }
            set
            {
                if (_typy != value)
                {
                    _typy = value;
                    OnPropertyChanged();
                }
            }
        }




        public RelayCommand<object> PridejZdrojCommand { get; private set; }
        public RelayCommand<object> OdeberZdrojCommand { get; private set; }
        public RelayCommand<object> OdeberKategoriiCommand { get; private set; }
        public RelayCommand PridejKategoriiCommand { get; private set; }
        public RelayCommand ZmenaStavuCommand { get; private set; }
        public RelayCommand ZmenaGeneraceCommand { get; private set; }
        public RelayCommand GenerujSQLSablonuCommand { get; private set; }
        public RelayCommand<object> RichTextBoxZpetCommand { get; private set; }
        public RelayCommand GenerujSablonuOpravnyKodCommand { get; private set; }

        public RelayCommand<object> TestCommand { get; private set; }

        public OdvozUkazDetailsViewModel(OU_ODVOZ_UKAZ VybranyOdvozenyUkazate)
        {
            if (!DesignerProperties.GetIsInDesignMode(new System.Windows.DependencyObject()))
            {
                // Code runs in Blend --> create design time data.
                //UlohyTeren = new ObservableCollection<ULOHA>(DBContext.Instance.Entity.ULOHA);
                FunkceKolekce = new ObservableCollection<OU_FUNKCE>(DBContext.Instance.Entity.OU_FUNKCE);
                Typy = new ObservableCollection<OU_TYP>(DBContext.Instance.Entity.OU_TYP);

                //GalaSoft.MvvmLight.Messaging.Messenger.Default.Register(this,
                //    new Action<GenericMessage<TransformationMessage>>(
                //message =>
                //{
                //    OdvozUkaz = VybranyOdvozenyUkazate;
                //});
                //GalaSoft.MvvmLight.Messaging.Messenger.Default.Register<OdvozUkazMessage>(this, this.Test);

                OdvozUkaz = VybranyOdvozenyUkazate;

                Funkce = OdvozUkaz.OU_FUNKCE;

                
                //Načtení kloekce témat:
                var serazeneTemata = DBContext.Instance.Entity.OU_TEMATA.Where(t => t.ULOHA_ID == OdvozUkaz.OU_TAB.ULOHA_METOD_OBDOBI.ID_ULOHA).ToList();
                serazeneTemata.Sort((klas1, klas2) => ExtensionMethods.RazeniKlasifikace(klas1.KOD, klas2.KOD));
                OUTemata = new ObservableCollection<OU_TEMATA>(serazeneTemata);


            }
            else
            {
                // Code runs "for real"
            }


            PridejZdrojCommand = new RelayCommand<object>((z) => PridejZdroj(z));
            OdeberZdrojCommand = new RelayCommand<object>((z) => OdeberZdroj(z));
            OdeberKategoriiCommand = new RelayCommand<object>((k) => OdeberKategorii(k));
            PridejKategoriiCommand = new RelayCommand(() => PridejKategorii());
            ZmenaStavuCommand = new RelayCommand(() => ZmenaStavu());
            ZmenaGeneraceCommand = new RelayCommand(() => ZmenaGenerace());
            GenerujSQLSablonuCommand = new RelayCommand(() => GenerujSQLSablonu());
            RichTextBoxZpetCommand = new RelayCommand<object>((o) => RichTextBoxZpet(o));
            GenerujSablonuOpravnyKodCommand = new RelayCommand(() => GenerujSablonuOpravnyKod());

            //TestCommand = new RelayCommand<object>((o) => Test(o));
        }


        
        internal void Test(object o)
        {
            
            
        }

        /// <summary>
        /// generuje šablonu pro plsql kód
        /// </summary>
        internal void GenerujSQLSablonu()
        {
            try
            {
                //Kontrola zda je vybrána fce Vlastní
                if (Funkce.NAZEV != "Vlastní")
                    throw new InvalidOperationException("Lze generovat pouze pokud je vybrána funkce Vlastní.");

                //Pokud již obsahuje nějaký sql kód, ujišťuji se, že pokračuji v generování 
                if (!string.IsNullOrEmpty(OdvozUkaz.SQL_DOTAZ))
                {
                    string zprava = string.Format("Opravdu si přejete generovat SQL šablonu?{0}Dojde ke ztrátě již vyplněného sql kódu.", Environment.NewLine);
                    MessageBoxResult mbr = MessageBox.Show(zprava, "Generování šablony SQL", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                    if (mbr != MessageBoxResult.Yes)
                        return;
                }

                //Zjištění primárních klíčů
                string propojeniPK = "";
                string pkVse = "";
                foreach (var pk in OdvozUkaz.OU_TAB.OU_PRIMARNI_KLICE.OrderBy(p => p.PORADI))
                {
                    propojeniPK = string.Format("{1}O.{0} = B.{0} AND ", pk.JMENO, propojeniPK);
                    pkVse = string.Format("{0}{1}, ", pkVse, pk.JMENO);
                }
                propojeniPK = propojeniPK.Substring(0, propojeniPK.Length - 4);//odstraním poslední AND
                //Vytvoření SQL kódu
                OdvozUkaz.SQL_DOTAZ =

$@"MERGE INTO {OdvozUkaz.OU_TAB.JMENO} O
USING (SELECT {pkVse} <ZDROJ> FROM <TABULKA>) B
ON ({propojeniPK})
WHEN MATCHED THEN UPDATE SET O.{OdvozUkaz.NAZEV} = <ZDROJ>";


                OnPropertyChanged("OdvozUkaz");

            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Generování šablony SQL", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        internal void GenerujSablonuOpravnyKod()
        {
            try
            {
                //Pokud již obsahuje nějaký opravný kód, ujišťuji se, že pokračuji v generování 
                if (!string.IsNullOrEmpty(OdvozUkaz.OPRAVNY_KOD))
                {
                    string zprava = string.Format("Opravdu si přejete generovat SQL šablonu?{0}Dojde ke ztrátě již vyplněného sql kódu.", Environment.NewLine);
                    MessageBoxResult mbr = MessageBox.Show(zprava, "Generování šablony opravného SQL", MessageBoxButton.YesNo, MessageBoxImage.Warning);
                    if (mbr != MessageBoxResult.Yes)
                        return;
                }

                OdvozUkaz.OPRAVNY_KOD = 
$@"BEGIN
	UPDATE {OdvozUkaz.OU_TAB.JMENO} SET {OdvozUkaz.NAZEV} = <Oprava> WHERE {string.Join("||",OdvozUkaz.OU_TAB.OU_PRIMARNI_KLICE.OrderBy(p => p.PORADI).Select(p => p.JMENO))} IN (<Hodnoty>);
END;";

                OnPropertyChanged("OdvozUkaz");
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Generování šablony opravného SQL", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            
        }

        /// <summary>
        /// Na změnmu generace vyhledá nejvyšší hodnotu pořadí v dané generaci a vloží tuto hodnotu + 1 do pořadí výpočtu
        /// </summary>
        internal void ZmenaGenerace()
        {
            if (OdvozUkaz.GENERACE != null)
            {
                var ostOUzeStejneGenerace = OdvozUkaz.OU_TAB.OU_ODVOZ_UKAZ.Where(o => o.GENERACE == OdvozUkaz.GENERACE && o != OdvozUkaz);
                int x = 0;
                if (ostOUzeStejneGenerace.Count() > 0)
                {
                    x = ostOUzeStejneGenerace.Max(o => o.PORADI_VYPOCTU);
                }
                OdvozUkaz.PORADI_VYPOCTU = x + 1;
                OnPropertyChanged("OdvozUkaz");
            }
        }

        /// <summary>
        /// Změna OU hotovo/nehotovo
        /// </summary>
        internal void ZmenaStavu()
        {
            try
            {
                OnPropertyChanged("PovolitZmenu");
            }
            catch (Exception)
            {

                throw;
            }
        }

        internal void PridejKategorii()
        {
            try
            {

                //foreach (var chyba in Validace.ValidacniChyby)
                //{
                //    if (OdvozUkaz.OU_CATEGORY.Any(c => c == chyba.Objekt))
                //    {
                //        throw new Exception("Kategorie obsahují validační chyby.");
                //    }
                //}


                //OdvozUkaz.OU_CATEGORY.Add(new OU_CATEGORY { OU_ODVOZ_UKAZ = OdvozUkaz });
                OU_CATEGORY newCat = new OU_CATEGORY();
                newCat.VlozitNouvouCategory(OdvozUkaz);
            }
            catch (Exception ex)
            {

                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Odebrat zdroj", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        internal void OdeberKategorii(object KategorieObj)
        {
            try
            {
                OU_CATEGORY kategorie = KategorieObj as OU_CATEGORY;
                //OdvozUkaz.OdeberKategorii(kategorie);
                DBContext.Instance.Entity.OU_CATEGORY.Remove(kategorie);
            }
            catch (Exception ex)
            {

                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Odebrat zdroj", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }




        internal void OdeberZdroj(object Zdroj)
        {
            try
            {
                if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(BDBC_SLOUPCE))
                {
                    OdvozUkaz.OdeberBdbcZdroj(Zdroj as BDBC_SLOUPCE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(OU_ODVOZ_UKAZ))
                {
                    OdvozUkaz.OdeberZdrojovyOdvozUkaz(Zdroj as OU_ODVOZ_UKAZ);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(BDBC_PRIMARNI_KLICE))
                {
                    OdvozUkaz.OdeberBdbcPK(Zdroj as BDBC_PRIMARNI_KLICE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(EXT_SLOUPCE))
                {
                    OdvozUkaz.EXT_SLOUPCE.Remove(Zdroj as EXT_SLOUPCE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(CISEL_SEZNAM))
                {
                    OdvozUkaz.OdeberCisel();
                }
                else
                {
                    throw new Exception("Neznámý datový typ.");
                }


            }
            catch (Exception ex)
            {
                string zprava = string.Format("Chyba:{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Odebrat zdroj", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        internal void PridejZdroj(object Zdroj)
        {
            try
            {
                if (!PovolitZmenu)
                {
                    throw new InvalidOperationException("Odvozený ukazatel je označen jako hotový nebo používá funkci jinou než Vlastní.");
                }

                if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(BDBC_SLOUPCE))
                {
                    OdvozUkaz.PridejBdbcZdroj(Zdroj as BDBC_SLOUPCE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(OU_ODVOZ_UKAZ))
                {
                    OdvozUkaz.PridejZdrojovyOdvozUkaz(Zdroj as OU_ODVOZ_UKAZ);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(BDBC_PRIMARNI_KLICE))
                {
                    OdvozUkaz.PridejBdbcPK(Zdroj as BDBC_PRIMARNI_KLICE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(EXT_SLOUPCE))
                {
                    OdvozUkaz.PridejExt(Zdroj as EXT_SLOUPCE);
                }
                else if (ObjectContext.GetObjectType(Zdroj.GetType()) == typeof(CISEL_SEZNAM))
                {
                    throw new NotImplementedException("Není implementováno.");
                }
                
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Nelze přidat zdroj k OU {2} chyba:{0}{1}", Environment.NewLine, ex.Message, OdvozUkaz.NAZEV);
                MessageBox.Show(zprava, "Přidej zdroj", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        /// <summary>
        /// Oprava funkce zpět (ctrl+z) u formátovaného textu v RichTextBoxu, je nutné ho provést dvakrát. První undo odstraní pouze sysntax highlighting a druhé undo je teprve provedená změna
        /// </summary>
        /// <param name="rtb"></param>
        internal void RichTextBoxZpet(object rtb)
        {
            var rtbSQL = (Xceed.Wpf.Toolkit.RichTextBox)rtb;
            if (rtbSQL.CanUndo)
                rtbSQL.Undo();
            if (rtbSQL.CanUndo)
                rtbSQL.Undo();
        }




    }


}
