﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using OuDot.Model;
using OuDot.ServicesOudot;
using Xceed.Wpf.AvalonDock;
using Xceed.Wpf.AvalonDock.Layout;
using System.Text.RegularExpressions;
using System.Windows.Threading;

namespace OuDot.ViewModel
{
    /// <summary>
    /// Interaction logic for OdvozUkazDetailsWindow.xaml
    /// </summary>
    public partial class OdvozUkazDetailsWindow : UserControl
    {
        public OdvozUkazDetailsWindow(OU_ODVOZ_UKAZ VybranyOU)
        {
            InitializeComponent();

            this.DataContext = new OdvozUkazDetailsViewModel(VybranyOU);

        }

        private void oU_ZDROJEDataGrid_MouseDobleClick(object sender, RoutedEventArgs e)
        {
            try
            {
                BDBC_SLOUPCE sloupec = (sender as DataGridRow).Item as BDBC_SLOUPCE;
                if (sloupec != null)
                {
                    RozsireniGrafika.Rozsireni.ZobrazCapiMetaData(sloupec, (this.Parent as DockingManager));
                }


                OU_ODVOZ_UKAZ ou = (sender as DataGridRow).Item as OU_ODVOZ_UKAZ;
                if (ou != null)
                    RozsireniGrafika.Rozsireni.OtevriOUOkno(ou, (this.Parent as DockingManager));
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Nelze otevřít detail zdroje.{0}Chyba:{0}{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Vyběr zdroje", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }



        private void oU_CATEGORYDataGrid_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            //zjistí zda byl doble click proveden na Prekodování
            string sloupec = (sender as DataGridCell).Column.SortMemberPath;
            if (sloupec == "OU_PREKODOVANI")
            {
                //Vyhledá řádek na který bylo poklikáno
                DependencyObject row = sender as DependencyObject;
                while (row != null && !(row is DataGridRow))
                {
                    row = VisualTreeHelper.GetParent(row);
                }
                //získá ze řádku kategorii a spustí okno pro nastavení překódování
                OU_CATEGORY kategorie = (row as DataGridRow).Item as OU_CATEGORY;
                PrekodovaniWindow pw = new PrekodovaniWindow(kategorie);
                pw.ShowDialog();

                oU_CATEGORYDataGrid.CommitEdit();
                oU_CATEGORYDataGrid.Items.Refresh();
            }


        }
        /// <summary>
        /// Pokud se změní výběr spustím validace na parametrch
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cbDatovyTyp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (iudP1 != null)
                this.iudP1.GetBindingExpression(Xceed.Wpf.Toolkit.IntegerUpDown.ValueProperty).UpdateSource();
            if (iudP2 != null)
                this.iudP2.GetBindingExpression(Xceed.Wpf.Toolkit.IntegerUpDown.ValueProperty).UpdateSource();
        }
        /// <summary>
        /// Pokud se změní hodnota parametru jedna sputím validace na parametru 2
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void iudP1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (iudP2 != null)
                this.iudP2.GetBindingExpression(Xceed.Wpf.Toolkit.IntegerUpDown.ValueProperty).UpdateSource();
        }
        /// <summary>
        /// Pokud upravím hodnotu Generace spustím validace na Pořadí výpočtu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void iupGENERACE_ValueChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (this.iupPORADI_VYPOCTU != null)
                this.iupPORADI_VYPOCTU.GetBindingExpression(Xceed.Wpf.Toolkit.IntegerUpDown.ValueProperty).UpdateSource();

        }



        /// <summary>
        /// Oprava bugu datagridu, kdy při odebrní nevalidního objektu zůstane v erorru a je potřeba obnovit imtesSource
        /// https://social.msdn.microsoft.com/Forums/vstudio/en-US/eae6c13f-11e5-46c4-88ac-e1f980a47614/wpf-datagrid-validation-fails-to-update-when-itemssource-item-is-removed?forum=wpf
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bOdeberCat_Click(object sender, RoutedEventArgs e)
        {

            this.oU_CATEGORYDataGrid.ItemsSource = null;
            Binding itemsSourceBindig = new Binding("OdvozUkaz.OU_CATEGORY");
            this.oU_CATEGORYDataGrid.SetBinding(DataGrid.ItemsSourceProperty, itemsSourceBindig);
        }




        /// <summary>
        /// Filtr na témata v ComboBox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ComboBox_KeyUp(object sender, KeyEventArgs e)
        {
            Key[] nefiltrKlavesy = new Key[] { Key.Down, Key.Up, Key.Left, Key.Right };
            if (nefiltrKlavesy.Contains(e.Key))
                return;



            ComboBox cmbTemata = sender as ComboBox;

            if (cmbTemata.SelectedItem != null)
            {
                cmbTemata.SelectedItem = null;
            }

            string filter = cmbTemata.Text.Trim();
            CollectionView itemsViewOriginal = (CollectionView)CollectionViewSource.GetDefaultView(cmbTemata.ItemsSource);

            itemsViewOriginal.Filter = ((o) =>
            {
                if (String.IsNullOrEmpty(cmbTemata.Text)) return true;
                else
                {
                    OU_TEMATA tema = o as OU_TEMATA;
                    if (string.IsNullOrEmpty(filter))
                    {
                        return false;
                    }
                    else
                    {
                        return tema.POPISEK.ToLower().Contains(filter.ToLower()) || tema.KOD.ToLower().Contains(filter.ToLower());
                    }


                    //if (((string)o).Contains(cmbTemata.Text)) return true;
                    //else return false;
                }
            });

            //itemsViewOriginal.Refresh();
        }

        /// <summary>
        /// Oprava scrollovani celého okna nad datagridem
        /// http://stackoverflow.com/questions/2922303/mouse-scroll-not-working-in-a-scroll-viewer-with-a-wpf-datagrid-and-additional-u
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void FilterDataGrid_PreviewMouseWheel(object sender, MouseWheelEventArgs e)
        {
            this.ouDetailScrollViewer.ScrollToVerticalOffset(this.ouDetailScrollViewer.VerticalOffset - e.Delta);
            e.Handled = true;
        }

       
        //#region RichTextBox formátování textu

        //private DispatcherTimer _tmrFormat = new DispatcherTimer();// na událost tick spouštím formátování kódu

        ///// <summary>
        ///// Změna textu v richTextBoxu, slouží k formátování plsql kódu
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void rtbSQL_TextChanged(object sender, TextChangedEventArgs e)
        //{
        //    //Zastavím timer a spouští odpočet odznovu
        //    _tmrFormat.Stop();
        //    _tmrFormat.Start();
        //}

        //struct ParagraphStruktura
        //{
        //    public Run Inline;
        //    public int indexStart;
        //}

        ///// <summary>
        ///// Vytvoří podle daného Tagu TextRange a přidá záznam do daného listu Tagů
        ///// </summary>
        ///// <param name="Tagy">List všech tagů k formátu</param>
        ///// <param name="InLines">všechny Inliny Paragrafu ze kterého je Tag</param>
        ///// <param name="Tag">Text, který budu formátovat</param>
        ///// <param name="TypFormatu">Druh formátu</param>
        //private void VytvorPridejTagNaRadku(List<TagFormat> Tagy, List<ParagraphStruktura> InLines, Match Tag, FormatPLSQLEnum TypFormatu)
        //{
        //    //Nejdříve vždy ve struktuře paragraphu je nutné vybrat správný Run (inline) na kterém náš Tag začíná a na kterém končí.
        //    //Poté na daném Run (inline) vyhledám spravný TextPointer začátku a konce a z toho vytvořím TextRange
        //    //Vyhledám ve struktůře pragarafu začátek máho Tagu
        //    ParagraphStruktura startStruc = InLines.Where(i => Tag.Index >= i.indexStart).OrderByDescending(i => i.indexStart).First();
        //    TextPointer start = startStruc.Inline.ContentStart.GetPositionAtOffset(Tag.Index - startStruc.indexStart, LogicalDirection.Forward);
        //    //Vyhládám konec Tagu
        //    ParagraphStruktura x = InLines.Where(i => (Tag.Index + Tag.Value.Length) >= i.indexStart).OrderByDescending(i => i.indexStart).First();
        //    TextPointer end = x.Inline.ContentStart.GetPositionAtOffset(Tag.Index + Tag.Value.Length - x.indexStart, LogicalDirection.Backward);
        //    Tagy.Add(new TagFormat { Text = new TextRange(start, end), DruhFormatu = TypFormatu, PlainText = Tag.Value });
        //}

        ///// <summary>
        ///// Zvýraznění syntaxe PLSQL
        ///// </summary>
        //private void ZvyrazneniSyntaxePLSQL()
        //{
        //    List<TagFormat> tagy = new List<TagFormat>();//List všech formátovaných částí textu
        //    TextPointer startGlobKoment = null;//Začátek globálního komentáře
        //    foreach (Paragraph p in rtbSQL.Document.Blocks)
        //    {

        //        // Run r = (Run)navigator.Parent;
        //        TextRange trParagraph = new TextRange(p.ContentStart, p.ContentEnd);

        //        List<ParagraphStruktura> inlines = new List<ViewModel.OdvozUkazDetailsWindow.ParagraphStruktura>();
        //        var sb = new StringBuilder();
        //        foreach (Run r in p.Inlines)
        //        {
        //            inlines.Add(new ParagraphStruktura { Inline = r, indexStart = sb.Length });
        //            sb.Append(r.Text);
        //        }

        //        //Vyhledání v textu v RUN veskerych shod textu obsaženého v <>
        //        var vsechnyBold = Regex.Matches(trParagraph.Text, "<(.*?)>");
        //        foreach (Match bold in vsechnyBold)
        //        {
        //            VytvorPridejTagNaRadku(tagy, inlines, bold, FormatPLSQLEnum.Bold);
        //        }

        //        //Formátovní pro všechna Oracle slova
        //        //http://phoboslab.org/log/2007/08/generic-syntax-highlighting-with-regular-expressions
        //        var vsechnyShody = Regex.Matches(trParagraph.Text, "(?:(?<!\\w|\\$|\\%|\\@|>)" + Validace.OraclePLSQLSlova + "(?!\\w))", RegexOptions.IgnoreCase);//Vyhledání všech shod se slovem v daném textu
        //        foreach (Match shoda in vsechnyShody)
        //        {
        //            VytvorPridejTagNaRadku(tagy, inlines, shoda, FormatPLSQLEnum.Modre);
        //        }

        //        //Formátování číslic
        //        var cisla = Regex.Matches(trParagraph.Text, "(?:(?<!\\w|\\$|\\%|\\@|>)\\d+(?!\\w))", RegexOptions.IgnoreCase);
        //        foreach (Match c in cisla)
        //        {
        //            VytvorPridejTagNaRadku(tagy, inlines, c, FormatPLSQLEnum.Oranz);
        //        }

        //        //Formátování textu v jednoduchých uvozovkách //bez uvozovek (?<![^']|^)(.*?)(?![^']|$) (nefunguje pro dalsi uvozovky v rade)
        //        var shodyUvozovky = Regex.Matches(trParagraph.Text, "'(.*?)'", RegexOptions.IgnoreCase);
        //        foreach (Match su in shodyUvozovky)
        //        {
        //            VytvorPridejTagNaRadku(tagy, inlines, su, FormatPLSQLEnum.SvetleModr);
        //        }

        //        //zakomentované radky DODĚLAT PŘI PROCHÁZENÍ CELÉHO TEXTU KOMENTÁŘ PRO 
        //        var shodyKomenty = Regex.Matches(trParagraph.Text, "--", RegexOptions.IgnoreCase);
        //        foreach (Match su in shodyKomenty)
        //        {
        //            //Vyhledám ve struktůře pragarafu začátek máho Tagu
        //            ParagraphStruktura startStruc = inlines.Where(i => su.Index >= i.indexStart).OrderByDescending(i => i.indexStart).First();
        //            TextPointer start = startStruc.Inline.ContentStart.GetPositionAtOffset(su.Index - startStruc.indexStart, LogicalDirection.Forward);

        //            TextRange tr = new TextRange(start, p.ContentEnd);//začátek řádku nebo pokud je null konec dokumentu
        //            tagy.Add(new TagFormat { Text = tr, DruhFormatu = FormatPLSQLEnum.Zelene, PlainText = su.Value });

        //        }

        //        //Globální komentář /*
        //        //1.Vyhledání gobálních komentářů na jednom řádku
        //        var shodyGlobKomentNaRadku = Regex.Matches(trParagraph.Text, "/\\*(.*?)\\*/", RegexOptions.IgnoreCase);
        //        foreach (Match sgknr in shodyGlobKomentNaRadku)
        //        {
        //            VytvorPridejTagNaRadku(tagy, inlines, sgknr, FormatPLSQLEnum.Zelene);
        //        }
        //        //2.Označení začátku a konce gobálního komentáře přes více řádků
        //        var zacaGlobKoment = Regex.Match(trParagraph.Text, @"\/\*((?!\*\/).)*$");//Vyhledání na řádku počátečního globálního komentáře, který není na řádku ukončen
        //        var konecGlobKoment = Regex.Match(trParagraph.Text, "\\*/");//Vyhledání 1. koncové značky globálního komentáře
        //        //Pokud existuje TextPointer na začátek globálního komentáře a zároveň byla nalezena ukončovací zančka
        //        if (startGlobKoment != null && konecGlobKoment.Success)
        //        {
        //            //Dohledám TextPointer na ukončovací značku a vytvořím Tag
        //            ParagraphStruktura startStruc = inlines.Where(i => i.indexStart <= konecGlobKoment.Index).OrderByDescending(i => i.indexStart).First();
        //            TextPointer end = startStruc.Inline.ContentStart.GetPositionAtOffset(konecGlobKoment.Index + konecGlobKoment.Length - startStruc.indexStart, LogicalDirection.Backward);
        //            TextRange tr = new TextRange(startGlobKoment, end);//začátek řádku nebo pokud je null konec dokumentu
        //            tagy.Add(new TagFormat { Text = tr, DruhFormatu = FormatPLSQLEnum.Zelene, PlainText = tr.Text });
        //            //Nastavím TextPointer začátku globálního komentáře na prázdnou hodnotu
        //            startGlobKoment = null;
        //        }
        //        //Pokud neexistuje TextPointer na začátek globálního komentáře a byl na řádku nalezen neukončený, tak ho vyhledám a vložím do proměnné
        //        if (startGlobKoment == null && zacaGlobKoment.Success)
        //        {
        //            ParagraphStruktura startStruc = inlines.Where(i => i.indexStart <= zacaGlobKoment.Index).OrderByDescending(i => i.indexStart).First();
        //            startGlobKoment = startStruc.Inline.ContentStart.GetPositionAtOffset(zacaGlobKoment.Index - startStruc.indexStart, LogicalDirection.Forward);
        //        }


        //    }
        //    //Po projetí celého textu zjistím zda exituje TextPointer na začátek globálního komentáře a pokud ano vytvořím Tag do konce celého textu
        //    if (startGlobKoment != null)
        //    {
        //        TextRange tr = new TextRange(startGlobKoment, startGlobKoment.DocumentEnd);
        //        tagy.Add(new TagFormat { Text = tr, DruhFormatu = FormatPLSQLEnum.Zelene, PlainText = tr.Text });
        //        startGlobKoment = null;
        //    }

        //    //Nastavení formátů
        //    Format(tagy);
        //}

        //private void _tmrFormat_Tick(object sender, EventArgs e)
        //{
        //    _tmrFormat.Stop();//timer zastavím

        //    //http://blogs.microsoft.co.il/tamir/2006/12/14/richtextbox-syntax-highlighting/
        //    //Převzato z návodu výše

        //    Xceed.Wpf.Toolkit.RichTextBox TextInput = rtbSQL;
        //    if (TextInput.Document == null)
        //        return;

        //    TextRange documentRange = new TextRange(TextInput.Document.ContentStart, TextInput.Document.ContentEnd);
        //    rtbSQL.TextChanged -= this.rtbSQL_TextChanged;
        //    //http://stackoverflow.com/questions/12065616/how-to-select-richtextbox-text-given-an-index-and-length
        //    rtbSQL.BeginChange();//Združí všechny provedené změny do jednoho undo kroku, dokud není spouštěna funkce EndChange
        //    //Nejdríve odstraním veškerý původní formát
        //    documentRange.ClearAllProperties();
        //    documentRange.ApplyPropertyValue(TextElement.FontFamilyProperty, new FontFamily("Segoe UI"));
        //    documentRange.ApplyPropertyValue(TextElement.FontSizeProperty, 12.00);
        //    rtbSQL.TextChanged += this.rtbSQL_TextChanged;

        //    ZvyrazneniSyntaxePLSQL();//Nastavení zvýraznění syntaxe
        //}

        ///// <summary>
        ///// Nastaví formát dle definic v daném listu
        ///// </summary>
        ///// <param name="TagList">List tagů k naformátování</param>
        //void Format(List<TagFormat> TagList)
        //{
        //    //Odeberu událost na změnu textu a po té nastavuji všechny formáty, které podle typu formátu aplikuji na dané TextRange
        //    rtbSQL.TextChanged -= this.rtbSQL_TextChanged;
        //    TagList = TagList.OrderBy(t => t.DruhFormatu.ToString()).ToList();
        //    foreach (TagFormat tf in TagList)
        //    {
        //        switch (tf.DruhFormatu)
        //        {
        //            case FormatPLSQLEnum.Bold:
        //                tf.Text.ApplyPropertyValue(TextElement.FontWeightProperty, FontWeights.Bold);
        //                break;
        //            case FormatPLSQLEnum.Modre:
        //                tf.Text.ApplyPropertyValue(TextElement.ForegroundProperty, new SolidColorBrush(Colors.Blue));
        //                break;
        //            case FormatPLSQLEnum.Zelene:
        //                tf.Text.ApplyPropertyValue(TextElement.ForegroundProperty, new SolidColorBrush(Colors.Green));
        //                break;
        //            case FormatPLSQLEnum.Oranz:
        //                tf.Text.ApplyPropertyValue(TextElement.ForegroundProperty, new SolidColorBrush(Colors.Orange));
        //                break;
        //            case FormatPLSQLEnum.SvetleModr:
        //                tf.Text.ApplyPropertyValue(TextElement.ForegroundProperty, new SolidColorBrush(Colors.BlueViolet));
        //                break;
        //            default:
        //                throw new NotImplementedException("Neznámí druh textového formátu.");
        //        }

        //    }
        //    rtbSQL.EndChange();//Ukončím sdružování změň
        //    rtbSQL.TextChanged += this.rtbSQL_TextChanged;

        //}

        ///// <summary>
        ///// Slouží k definování textového řetězce, který budu formátovat
        ///// </summary>
        //struct TagFormat
        //{
        //    public TextRange Text;
        //    public FormatPLSQLEnum DruhFormatu;
        //    public string PlainText;
        //}


        //private void rtbSQL_KeyUp(object sender, KeyEventArgs e)
        //{
        //    if (e.Key == Key.Tab)
        //    {
        //        //Oprava chování RichTextBoxu při vkládání tabulátoru na začátek řádku, standardně RichTextBox vkládá pouze indention (odsazení) což se neukládá do textu. Proto ruším nastavení TextIndent a vkládám na pozici tabulátor
        //        if (rtbSQL.CaretPosition.IsAtLineStartPosition)
        //        {
        //            rtbSQL.CaretPosition.InsertTextInRun("\t");
        //            rtbSQL.CaretPosition.GetLineStartPosition(0).Paragraph.TextIndent = 0;
        //        }

        //    }
        //}


        //#endregion RichTextBox formátování textu




    }


}
