﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using BolapanControl.ItemsFilter;
using OuDot.Model;
using Xceed.Wpf.AvalonDock;
using Xceed.Wpf.AvalonDock.Layout;

namespace OuDot.ViewModel
{
    /// <summary>
    /// Interaction logic for TabulkaDetailsWindow.xaml
    /// </summary>
    public partial class TabulkaDetailsWindow : UserControl
    {
        public TabulkaDetailsWindow(OU_TAB VybranaTabulka)
        {
            InitializeComponent();
            this.DataContext = new TabulkaDetailsViewModel(VybranaTabulka);
        }

        private void oU_ODVOZ_UKAZDataGrid_MouseDobleClick(object sender, RoutedEventArgs e)
        {
            try
            {
                
                OU_ODVOZ_UKAZ ou = (sender as DataGridRow).Item as OU_ODVOZ_UKAZ;
                if (ou != null)
                    OtevriOUOkno(ou);
            }
            catch (Exception ex)
            {
                string zprava = string.Format("Nelze otevřít detail zdroje.{0}Chyba:{0}{0}{1}", Environment.NewLine, ex.Message);
                MessageBox.Show(zprava, "Vyběr zdroje", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }


        public void OtevriOUOkno(OU_ODVOZ_UKAZ OdvozUkaz)
        {
            LayoutDocumentPane LDP = (this.Parent as DockingManager).Layout.Descendents().OfType<LayoutDocumentPane>().FirstOrDefault();

            //Vyhledání zda okno s ou již existuje
            var vsechnyLD = (this.Parent as DockingManager).Layout.Descendents().OfType<LayoutDocument>();
            LayoutContent OknoVybOU = vsechnyLD.FirstOrDefault(p => (p.Content.GetType() == typeof(OdvozUkazDetailsWindow)) && ((p.Content as OdvozUkazDetailsWindow).DataContext as OdvozUkazDetailsViewModel).OdvozUkaz == OdvozUkaz);

            if (OknoVybOU == null)//Vytvářím nové okno
            {
                //Vytvořím a nastavím okno pro detaili tabulky
                OdvozUkazDetailsWindow oudw = new OdvozUkazDetailsWindow(OdvozUkaz);
                //(oudw.DataContext as OdvozUkazDetailsViewModel).OdvozUkaz = OdvozUkaz;
                //Vložím vytvořené okno jako LeyoutDocument a s aktivním ho
                LayoutDocument ld = new LayoutDocument
                {
                    Content = oudw
                };

                //Nabinduju titul okna s nazvem ou
                Binding titulBinding = new Binding();
                titulBinding.Source = oudw.DataContext;
                titulBinding.Path = new PropertyPath("OdvozUkaz.NAZEV");
                BindingOperations.SetBinding(ld, LayoutDocument.TitleProperty, titulBinding);

                //Nabinduji IsBusy property:
                Binding isBusy = new Binding("IsBusy");
                isBusy.Source = this.DataContext;
                //isBusy.Path = new PropertyPath();
                isBusy.Converter = new RozsireniGrafika.InverseBooleanConverter();
                BindingOperations.SetBinding(oudw, TabulkaDetailsWindow.IsEnabledProperty, isBusy);

                LDP.Children.Add(ld);
                ld.IsActive = true;
            }
            else//aktivuji již existující
            {
                OknoVybOU.IsActive = true;
            }
        }

       
    }
}
